;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Text importer utility - ACC for Publishing Partner;
; by Mat*Rat                                        ;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
 
;
; Important constants definitions:
;
SPACE = 32
CR = 13
LF = 10
TAB = 9
TRUE = $FFFF
FALSE = $0000
TEXT_TYPE = 0
DEGAS_TYPE =1
ABORT = 2
;
 
start:  move.l #ustack,a7
        jsr iniz
        move.w menu_id,d0
        cmp.w #6,d0             ; Accessory list full?
        blt go_man_go           ; No, do it!
        move.l #0,(a7)          ; Yup, exit
        trap #1
go_man_go:      jsr main
        bra go_man_go           ; Never end an ACC
;
;;; MAIN CODE GOES HERE ;;;
;

main:   move.w #23,contrl       ; event_mesag
        clr.w contrl+2
        move.w #1,contrl+4
        move.w #1,contrl+6
        clr.w contrl+8
        move.l #msg_pipe,addrin ; Point to msg pipe buffer
        jsr aes
        move.w msg_pipe,d0
        cmp.w #40,d0            ; AC_OPEN Command?
        bne main                ; Nope, wait
        move.w msg_pipe+8,d0    ; Yup, check the ident
        cmp.w menu_id,d0        ; Calling Us?
        bne main                ; Nope, wait
 
;
; Begin IMPORT converter
 
restart:
  
        move.l #IMPORT,d1 ;Import accessory [Text|Degas|abort]
        jsr ring
        subq.w #1,d0      ; 0=text, 1=degas, 2=abort
        move.w d0,type
        cmp.w #ABORT,d0
        beq main

       jsr curdrv       ; Keep their current drive for prosperity
       move.w d0,kepdrv
       jsr drvset        ; Make current in our fsiinpath, *.TXT
       move.l #kepth,a0  ; Save path too
       jsr getdir


;
; Text file with carriage return for every line and optional LF,
; double carriage return for columns and new paragraphs.
; Tabs will be converted to single spaces. LFs ignored.  If a LOT
; control characters less than 32 or greater than 126 are encountered
; a warning may be posted indicating that the file didn't much look
; like a text file.
;
; Prompt for TEXT filename to read, after reminder:
 
        move.l #GODEGAS,d1
        tst.w type
        bne do_degas
        move.l #GOTEXT,d1   ;TEXT file to IMPORT.TXT [OK]
do_degas: jsr ring          ;a reminder
        tst.w type          ; DEGAS?
        bne filing          ; Yes, do the filing
        move.l #FOREIGN,d1  ; TEXT, allow foreign characters?
        jsr ring
        subq.w #1,d0        ; 0=NO, 1=YES
        move.w d0,fflag
 
;
; Now select the file to read:
;
filing: jsr fsel          ; Select a filename
        tst.b fsiinsel    ; A filename?
        beq error1        ; No file selected - abort
 
        JSR END_PATH       ; FIND END OF CURRENTLY SELECTED PATH
        move.b #0,(a1)
        move.l #fsiinpath+2,a0
        jsr set_pth
        bmi error5        ; Bad Path!? - restore old path/drive & exit
;
; Did he/she select IMPORT.TXT as input file?
; that IS a NONO!
;
        move.l #fsiinsel,a1     ; Specified filename
        move.l #DIMPFIL,a0
        tst.w type              ; non zero, degas type
        bne ckfil
        move.l #IMPFIL,a0       ; Output filename
ckfil:  jsr str_tst             ; test string (a0) against (a1)
;
; a0's len is assumed to be less than or equal to a1
; Strings end in a null (\0 in C notation).
; return a zero flag text BEQ or BNE will be valid
;
        bne dopen               ; Not eqal - AOK!
;
;       Tried to make input=output - same file, not good
;
        move.l #NOCANDO,d1
        jsr ring
        bra lmain
;
; File to read has been selected. Open for READ ONLY now.
;

dopen:
        move.l #fsiinsel,a1
        tst.w type              ; Degas type?
        beq dopen1              ; Nope, no problem
        jsr setrez              ; YES, set rez on filename & dialog
        move.l #fsiinsel,a1
        tst.w d0                ; NO rez?
        beq dopen1
        move.l #NOREZ,d1
        jsr ring
        bra lmain
dopen1: move.l #0,d0      ; Open for read only
        jsr open
        bmi error2        ; Open for read error?
;
; Use same drive/path, but filename IMPORT.TXT/PI3 for output.
;
        move.l #IMPFIL,a0 ; filename address
        tst.w type
        beq crefil
        move.l #DIMPFIL,a0
crefil: jsr create
        bmi error6        ; file create error?
;
; File created for output - handle in D0.W
;
        move.w d0,outhandl
;
; Iniz INPUT and OUTPUT counter variables
; and End of INPUT file, and 1st CR flags. Clear also LT32CNT -
; less than ASCII 32 counter. If it gets big - then  indicate
; NON text file has been "converted"
;
        move.w #34,color_cnt    ; If degas, skip 34 rez & color bytes
        move.w #1025,BYTSIN     ; Total bytes to read + 1
        move.w #FALSE,EOFLG     ; Clear end of file flag
        move.w #FALSE,CRFLAG    ; Clear carriage return count flag
        clr.l LT32CNT           ; Non text character counter
;
; READ a 1K block from file setup at -fhandle-
;
readloop:
        move.w fhandle,d0
        move.l #1024,d1   ; Ammount to read
        move.l #buffin,a0 ; Buffer input address
        jsr read          ; Attempt to read 1024 bytes
        bmi error3        ; Unexpected read error
        cmp.w #1024,d0
        beq process       ; Got all 1024 - process for output
        move.w #TRUE,EOFLG   ; Set end of file flag
        addq.w #1,d0
        move.w  d0,BYTSIN ; Total bytes in that record + 1
;
; Done reading - close input file
;
        move.w fhandle,d0
        jsr close         ; Go ahead and close completed input file
;
; Now process input bytes to outputs, gobbling LFs and unecessary
; carriage returns.
;
process:
        move.w #0,d1      ; Initialize loop counter
        move.l #buffin,a0 ; Input buffer pointer
        move.l #buffout,a1 ; and separate output buffer pointer
 
;
; Note that not all values INPUT will end up in the OUTPUT
; thus, two separate pointers are necessary. Easier to copy
; from buffin to buffout, selectively, than to delete "bad" bytes
; in buffin.  We don't need to be _that_ memory efficient on the ST!
;

loop:   tst.w type
        beq tloop

dloop:  addq.w #1,d1     ; Invert a DEGAS
        cmp.w BYTSIN,d1  ; picture byte for byte
        beq sendthem
        move.b (a0)+,d0
        tst.w color_cnt  ; skipped header yet?
        beq dloop1
        sub.w #1,color_cnt
        bra dloop2
dloop1: eori.b #$FF,d0
dloop2: move.b d0,(a1)+
        bra dloop
 
tloop:  addq.w #1,d1      ; Update loop count
        cmp.w BYTSIN,d1   ; ALL done?
        beq sendthem      ; Yes - send processed bytes
        move.b (a0),d0    ; No - read inbyte
        addq.l #1,a0      ; Point to next
        cmp.b #LF,d0      ; Ignore line feeds
        beq loop          ; Because so does PP Importer
        cmp.b #TAB,d0     ; Convert a tab to a space
        bne loop1
        move.b #SPACE,d0
        bra donext1
loop1:  cmp.b #CR,d0      ; Carriage return?
        bne loop2
        tst.w CRFLAG      ; got one already?
        bne donext1       ; Yup - so keep this one
        move.w #TRUE,CRFLAG
        move.b #SPACE,d0  ; single CR becomes a SPACE
        bra donext2       ; But don't clear CRFLAG
loop2:  tst.w fflag       ; Allow foreign chars?
        bne donext1
        cmp.b #126,d0     ; Less than 127?
        ble loop3
badchr: add.l #1,LT32CNT  ; Update non text char count
        bra tloop          ; and ignore
loop3:  cmp.b #32,d0      ; Control char, not CR,LF,TAB?
        blt badchr        ; then ignore and count also
donext1: clr.w CRFLAG     ; A non CR, printable char resets CRFLAG
donext2: move.b d0,(a1)   ; Keep a character
        addq.l #1,a1
        cmp.b #CR,d0      ; a CR, then keep an LF
        bne tloop          ; so you can still SHOW or PRINT file
        move.b #LF,(a1)
        addq.l #1,a1
        bra tloop
;
; Now send BUFFOUT to the file
;
sendthem:
        sub.l #BUFFOUT,a1 ; Convert pointer to counter
        move.l a1,d1
        tst.l d1          ; 0 bytes moved?
        beq finito        ; well, all done then
        move.w outhandl,d0      ; handle in d0.w
        move.l #BUFFOUT,a0      ; addr in a0.1, len in d1.l
        jsr write               ; for WRITE routine
        bmi error7
        tst.w EOFLG       ; Read to EOF yet?
        beq  readloop     ; No - continue
        move.l #2,d1
        move.w outhandl,d0
        move.l #LAST,a0   ; add a CR/LF at end of file
        jsr write
        bmi error7
;
; Close output file now that we're done
;
finito:
        move.w outhandl,d0
        jsr close

        move.w type,d3
        cmp #DEGAS_TYPE,d3
        beq skipwarn
;
; Check for LOTS of non-Text in file
;
        move.l LT32CNT,d0
        cmp.l #100,d0     ; Arbitrary value really
        blt finetext
;
; Doesn't look good. Tell him/her
;
        move.l #WARN,d1
        jsr ring
;
; Now exit
;
finetext:
        move.l #DONE,d1
        jsr ring
        bra pirmsg

skipwarn:
        move.l #PICDONE,d1
        jsr ring

; 10% of the time you get an anti piracy msg
; Random function returns a 24 bit long value between
; 0 and $0FFFFFF (1677215).  10% of that is $0199999 (167721)
;
pirmsg:
        move.w #17,-(sp)  ; Random function
        trap #14
        cmp.l #$0199999,d0
        bgt lmain         ; 90% chance no anti piracy msg.
;
; Not nice to PIRATE
;
        move.l #PIRATE,d1
        jsr ring
        bra lmain
;
; Error prompter routine
;
error1: move.l #erfstx,d1       ; fsel error
        bra exit1
error2: move.l #eroptx,d1
        bra exit1               ; open error
error3: move.l #errdtx,d1       ; Read error
        bra exit1
error5: move.l #errptx,d1       ; Path Error
        bra exit1
error6: move.l #ercrex,d1       ; Create error
        bra exit1
error7: move.l #erwrix,d1       ; Write error
        bra exit1
error4: move.l #ercltx,d1       ; Close error
exit1:  jsr ring
lmain:  move.w fhandle,d0       ; Make sure everyone is closed
        jsr close
        move.w outhandl,d0
        jsr close
        move.w kepdrv,d0
        jsr setdrv              ; Restore current drive
        move.l #kepth,a0
        jsr set_pth             ; Restore path directory
        bra main
;
;
;
 
aes:
        move.l  #aespb,d1
        move.w  #$c8,d0
        trap    #2
        rts
;
;
ring:   move.l  #contrl,a5      ; Form_Alert, dial one up, ringing
        move.w  #52,(a5)        ;opcode
        move.w  #1,2(a5)
        move.w  #1,4(a5)
        move.w  #1,6(a5)
        move.w  #0,8(a5)
        move.l  #intin,a5
        move.w  #1,(a5)         ;first button = return default
        move.l  #addrin,a5
        move.l  d1,(a5)
        jsr     aes
        move.w  intout,d0       ; Return Selection
        rts
;
iniz:
        move.l  #0,ap1resv
        move.l  #0,ap2resv
        move.l  #0,ap3resv
        move.l  #0,ap4resv
        move.w  #10,opcode      ; apl_init
        move.w  #0,sintin
        move.w  #1,sintout
        move.w  #0,saddrin
        move.w  #0,saddrout
        jsr     aes
 
        move.w intout,ap_id
;
; MENU_REGISTER - hook in accessory
;
        move.w #35,contrl
        move.w #1,contrl+2
        move.w #1,contrl+4
        move.w #1,contrl+6
        clr.w contrl+8
        move.w ap_id,intin
        move.l #accttl,addrin
        jsr aes
        move.w intout,menu_id
 
; Set default file path, and current drive specifier
 
drvset: move.l #PATH,a0
        tst.w type
        beq drvset1
        move.l #PPATH,a0
drvset1:
        move.l #fsiinpath,a1
        move.l #9,d1
coppth: move.b (a0)+,(a1)+      ; Copy text path
        dbf d1,coppth

; ensure that we have current drive #

        jsr curdrv              ; What is current drive?
        add.w #65,d0            ; Convert to drive Letter
        move.b d0,fsiinpath     ; Set it
        rts
 
 
 
; File selection input routine
; Do FSEL function now:
 
fsel:   move #90,contrl
        clr.w contrl+2
        clr.w contrl+8
        move.w #2,contrl+4
        move.w #2,contrl+6
        move.l #fsiinpath,addrin
        move.l #fsiinsel,addrin+4
        jsr aes
 
; Now set drive # according to user specification in FSEL

        move.w intout+2,d0      ; file selected check?
        cmp.w #0,d0             ; cancel button?
        bne enfsel              ; no - continue
        move.b #0,fsiinsel      ; yes - same as no file selected
enfsel: clr.w d0
        move.b fsiinpath,d0
        sub.w #65,d0
        jmp setdrv

; Set Path
; Entry: Path address in A0
;
set_pth:
        move.l a0,-(sp)
        move.w #$3b,-(sp)
        trap #1
        addq.l #6,sp
        tst.w d0
        beq set_pth1
        move.l #-1,d0
        tst.l d0        ; Return minus status if path error
        rts
set_pth1: clr.l d0
        tst.l d0
        rts
 
; Find the end of fsiinpath.  Search forward until a zero is
; found, then backup to the first "\" and point to the 1st
; byte After that in A1.
;
end_path:
        move.l #63,d0
        move.l #fsiinpath,a1
 
tst_azro:
        move.b (a1),d1          ; Zero byte?
        cmp.b #0,d1
        beq fnd_end             ; Yup, found it
        addq.l #1,a1
        dbf d0,tst_azro         ; Loop
        move.l #fsiinpath+2,a1  ; Not found, default
        rts
;
; Set REZ digit in filename and final output
; dialog for DEGAS conversions
;
setrez: move.l a1,d1
        add.l #64,d1            ; Max file length checker
setrez1: move.b (a1)+,d0         ; Grab a byte
        tst.b d0                ; End of string marker?
        beq badrez               ; No rez in extender then?
        cmp.b #".",d0           ; At extender?
        beq gotrez              ; Gotit, finish up rez
        cmp.l d1,a1             ; Past end of filename max?
        bne setrez1             ; Nope, continue
badrez:  move.w #-1,d0           ; Error flag
        rts
gotrez: move.b (a1)+,d0         ; P in PIx extender?
        cmp.b #"P",d0
        bne badrez
        move.b (a1)+,d0         ; I in PIx extender?
        cmp.b #"I",d0
        bne badrez
        move.b (a1)+,d0         ; this is x in PIx extender
        move.b d0,FREZ
        move.b d0,DREZ
        clr.w d0
        rts
;
; a1 now points to 0 after fsiinpath
;
fnd_end:
        suba.l #1,a1
        move.b (a1),d1
        cmp.b #"\",d1           ; End path marker?
        beq got_end             ; Yup, just about done
        cmp.l #fsiinpath,a1
        bgt fnd_end
        move.l #fsiinpath+2,a1  ; Error, default
        rts
 
got_end:
        addq.l #1,a1            ; 1st byte after
        rts
 
 
; open file: 0=read only 1=write only 2=read and write, in D0
 
open:     move.w d0,-(sp)     ; open type
          move.l #fsiinsel,-(sp)
          move.w #$3d,-(sp)
          trap #1             ; gemdos function
          addq.l #8,sp
          move.w d0,fhandle
        tst.w d0
          rts
 
;
; READ file already open, len reqd in D1, buff adr in A0, file handle
; in D0 (i.e. General Purpose read routine.)
;
 
read:     move.l a0,-(sp)     ; buffer address
          move.l d1,-(sp)     ; length to load
          move.w d0,-(sp)     ; current file handle
          move.w #$3f,-(sp)   ; gemdos function
          trap #1
          add.l #12,sp
          tst.l d0
          rts
; minus result is error, otherwise D0=# bytes read
 
; WRITE file already open, len. required in D1, buff adr in A0
; handle in D0.W
; Standard Handles: 0=console input, 1=console output
;                   2=RS-232, 3=Printer
;
 
pstrng: move.w #1,d0    ; Print String on display
lprint: move.w #3,d0    ; Setup for printer output
write:  move.l a0,-(sp) ; General form of Write
        move.l d1,-(sp)
        move.w d0,-(sp)
        move.w #$40,-(sp)
        trap #1
        add.l #12,sp
        tst.l d0
        rts
; minus result is error
 
; CREATE: create a new file
; Entry: A0=addr of filename
; Exit: D0.W=-1 if error, file handle otherwise
;
create: move.w #0,-(sp) ; R/w access
        move.l a0,-(sp)
        move.w #$3c,-(sp)
        trap #1
        addq.l #8,sp
        tst.w d0
        rts
; minus result is error
 
; SETDRV: Set drive number.
; Entry: D0.W = drive number, 0=A 1=B etc
 
setdrv: move.w d0,-(sp)         ; Drive #
        move.w #$0e,-(sp)       ; Set Drive
        trap #1
        addq.l #4,sp
        rts
 
;
; GETDIR: find current directory path of current drive
; Entry: A0 points to a 64 byte buffer
 
getdir: move.w #0,-(sp) ; Default drive, 1=A 2=B etc
        move.l a0,-(sp)
        move.w #$47,-(sp)
        trap #1
        addq.l #8,sp
        tst.l d0        ; error if minus
        rts
 
; CURRENT DRIVE: find current drive and return in D0.B
; 0=A, 1=B etc.
 
curdrv:  move.w #$19,-(sp)       ; What is current drive?
        trap #1
 
        addq.l #2,sp
        rts
 
; CLOSE - close current file handle
 
close:    move.w d0,-(sp)
          move.w #$3e,-(sp)
          trap #1
          addq.l #4,sp
          tst.w d0
          rts
;
; string test - compare string pointed to by a0.l to string at
; a1.l   The strings are terminalted by nulls.  It is assumed
; that string (a0) is is the same or greater length than
; that at (a1).  This routine returns a zero flag clear or set,
; for BEQ/BNE conditionals. a0, a1, d0, and d1 are changed.
;

str_tst: move.b (a0)+,d0        ; Read a byte from source string
        cmp #0,d0               ; is it a null?
        bne str_tst1            ; no, continue test
        rts                     ; yes - then EQUAL strings
str_tst1:
        move.b (a1)+,d1
        cmp.b d0,d1             ; this char equal?
        beq str_tst             ; Yes - then continue
        rts                     ; Not equal - home jives

 
;; DATA Area for IMPORTER ACC
 
        data
        align.w
 
msg_pipe:       dc.l 0,0,0,0
menu_id:        dc.w 0
ap_id:          dc.w 0
fsiinsel:       dc.b 0,0,0,0,0,0,0,0,0,0,0,0,0,0
fsiinpath:      dc.b "A:\*.TXT"
                dc.l 0,0,0,0,0,0,0,0,0,0,0,0,0,0

type:           dc.w 0          ; Text or Degas type conversion
fflag:          dc.w 0          ; Allow foreign characters flag
color_cnt:      dc.w 0          ; Degas color table skip counter

PATH:           dc.b "A:*.TXT",0,0

PPATH:          dc.b "A:*.PI?",0,0
 

errdtx: dc.b "[3][Error During | file read ][abort]"
eroptx: dc.b "[3][Open Error!][abort]"
ercltx: dc.b "[3][Close Error!][abort]"
ercrex: dc.b "[3][Can't Create File!][abort]"
erwrix: dc.b "[3][File Write Error!][abort]"
erfstx: dc.b "[3][No File | Selected ][exit]"
errptx: dc.b "[3][Pathname Error!][abort]"

LAST:   dc.b CR,LF,CR,LF
 
IMPORT:   dc.b "[2]"
          dc.b "[ Publishing Partner (tm)   |"
          dc.b  " text to IMPORT file       |"
          dc.b  " converter by Mat*Rat,     |"
          dc.b  " Editor ANALOG/ST-Log!     ]"
          dc.b  "[Text  | Degas  | Cancel  ]"
GOTEXT:   dc.b "[1]"
          dc.b "[ Convert a TEXT file with   |"
          dc.b  " a CR on every line. Double |"
          dc.b  " CRs mark paragraph. Output |"
          dc.b  " file will be: IMPORT.TXT  ]"
          dc.b  "[OK!]"
NOREZ:    dc.b  "[1]"
          dc.b  "[ Degas Filetype Error |"
          dc.b  "  MUST be .PI1, .PI2,  |"
          dc.b  "  or .PI3, UNCOMPRESSED|"
          dc.b  "  DEGAS file ONLY!     ]"
          dc.b  "[RATS!]"
FOREIGN:  dc.b  "[2]"
          dc.b  "[ Do you EXPECT      |"
          dc.b  "  foreign characters |"
          dc.b  "  in your text file? ]"
          dc.b  "[NO  | YES ]"
GODEGAS:  dc.b  "[1]"
          dc.b  "[ Convert DEGAS file   |"
          dc.b  "  from NEGATIVE to     |"
          dc.b  "  POSITIVE for picture |"
          dc.b  "        IMPORTING!     ]"
          dc.b  "[Go For It!]"
WARN:     dc.b "[1]"
          dc.b "[ There were a LOT of  |"
          dc.b  " NONTEXT characters in|"
          dc.b  " your source file!    ]"
          dc.b  "[Warning!]"
PICDONE:  dc.b  "[1]"
          dc.b  "[ File IMPORT.PI"
DREZ:     dc.b  "3 is |"
          dc.b  " ready to Import in  |"
          dc.b  " Publishing Partner! ]"
          dc.b  "[OK-Thanx Mat]"
DONE:     dc.b  "[1]"
          dc.b  "[ File IMPORT.TXT is |"
          dc.b   " ready to Import in |"
          dc.b   " Publishing Partner! ]"
          dc.b   "[OK-Thanx Mat]"
PIRATE:   dc.b  "[3][     Piracy is THEFT!       |"
          dc.b       " Support: SPA &          "
          dc.b $0E,$0F
          dc.b       " |"
          dc.b       " 1111 19th St. N.W.        |"
          dc.b       " Suite 1200                |"
          dc.b       " Washington, D.C. 20036    ]"
          dc.b       "[Piracy Hurts!]"
NOCANDO:  dc.b "[3]"
          dc.b "[ NO CAN DO! Filename  |"
          dc.b  " conflict. If you     |"
          dc.b  " want to convert file |"
          dc.b  " IMPORT.??? then you  |"
          dc.b  " must RENAME it first! ]"
          dc.b   "[Abort Import!]"

accttl:   dc.b   " Importer ",$0E,$0F,$20,0
 
IMPFIL:   dc.b  "IMPORT.TXT",0
DIMPFIL:  dc.b  "IMPORT.PI"
FREZ:     dc.b  "3",0
        align.w
aespb:
        dc.l   contrl,global,intin,intout,addrin,addrout
 
vdipb:  dc.l contrl,intin,ptsin,intout,ptsout
 
        bss
        align.w
 
contrl:
opcode: ds.w   1
sintin: ds.w   1
sintout: ds.w  1
saddrin: ds.w  1
saddrout: ds.l 1
 
        ds.w   5
 
global:
apversion:      ds.w   1
apcount:        ds.w   1
apid:           ds.w   1
apprivate:      ds.l   1
apptree:        ds.l   1
ap1resv:        ds.l   1
ap2resv:        ds.l   1
ap3resv:        ds.l   1
ap4resv:        ds.l   1
 
intin:          ds.w   128
 
ptsin:          ds.w   128
 
intout:         ds.w   128
 
ptsout:         ds.w   128
 
addrin:         ds.w   128
 
addrout:        ds.w   128
 
 
grhandle:       ds.w   1       ; Graphics handle
 
 
outhandl:      ds.w 1
fhandle:       ds.w 1
fsireturn:     ds.w 1
fsiexbutton:   ds.w 1
 
 
 
kepth:          ds.b    64      ; System default path
kepdrv:         ds.w    1       ; System default drive
 
BYTSIN:         ds.w    1       ; Byte count from READ
EOFLG:          ds.w    1       ; End of file found flag
CRFLAG:         ds.w    1       ; Carriage Return flag marker
LT32CNT:        ds.l    1       ; NONTEXT character counter
 
buffin:         ds.b 1024 ; 1 kbyte buffer for input
buffout:        ds.b 1024 ; 1 kbyte buffer for output
 
        ds.l    256
ustack: ds.l   1
       end
