/****************************************************************
 *
 * COMPRFAT
 *
 ***************************************************************/

#include <osbind.h>
#include <gemdefs.h>
#include <obdefs.h>
#include "COMPRFAT.H"

#define   say(x)    Cconws((x))
#define   Getbpb(a) bios(7,(a))

struct    {
          long v_free, v_total, v_secsize, v_clsiz;
          }    volfrinf;

struct    {
          int b_recsiz, b_clsiz, b_clszb,
              b_rdlen,  b_fsiz,  b_fatrec,
              b_datrec, b_numcl, b_bflags;
          }   *p_bpb;

int  vdi_handle, contrl[12], 
     intin[128], ptsin[128],
     intout[128],ptsout[128],
     work_in[12] = {1,1,1,1,1,1,1,1,1,1,0,0},
     work_out[57], rsc_loaded = 0;

long  maintree, devstree, infotree;

int   drv_in,
      fhandle,                          /* File handle for output      */
      n_fatsec,                         /* # of sectors in FAT         */
     *p_membuf = 0L;                    /* pointer to all allocated mem*/

long  drv_bits,
      l_fatbuf = 0L;

char  bkup_path[] = "?:\\BCKFAT?.BCK";

char  pr_cmp1[] = "  Compare primary & backup FATs on",
      pr_cmp2[] = "           which device?",
      pr_bck1[] = " ",
      pr_bck2[] = "   Backup FATs from which device?",
      pr_rst1[] = " ",
      pr_rst2[] = "   Restore FATs to which device?",
      pr_p2b1[] = "    Copy primary FAT to backup",
      pr_p2b2[] = "         on which device?",
      pr_b2p1[] = "    Copy backup FAT to primary",
      pr_b2p2[] = "         on which device?";
      

char  no_rsrc_alert[]   = "[3][ RESOURCE FILE NOT FOUND ][ CANCEL ]",
      no_mem_alert[]    = "[3][Memory allocation for |FAT buffer failed ][ CANCEL PROGRAM ]",
      read_fail_alert[] = "[3][ERROR - Read Failure on |primary or backup FAT.| ][ CANCEL PROGRAM ]",
      cmpr_fail_alert[] = "[2][ |The primary and backup |FATs are NOT equal. ][ BUMMER ]",
      cmpr_good_alert[] = "[0][|Successful compare: |The primary and backup  |FATs are identical.  | ][ OK ]",
      bkup_dev_alert[]  = "[0][|The backup process creates    |a file named BCKFAT?.BCK |(?=inp device) on the output|drive.  Choose drive:|][ A | B |CANCEL]",






      bkup_noab_alert[] = "[3][You cannot backup or restore |the FATs for a floppy disk...|This function is for hard|disks only.|][ CANCEL ]",
      bkup_fcre_alert[] = "[3][|File create for backup |failed on floppy.|][ CANCEL ]",
      bkup_fwrt_alert[] = "[3][|File write failed during|backup, no backup done.|][ ACKNOWLEGE ]",
      bkup_cmpl_alert[] = "[0][ | |Backup completed successfully.| |][ OK ]",
      rstr_dev_alert[]  = "[0][|The restore process reads     |a file named BCKFAT?.BCK|(?=out device) from input.|Choose input drive:|][ A | B |CANCEL]",
      rstr_open_alert[] = "[3][Open of backup file failed|on floppy, restore not|done.|][ CANCEL ]",
      rstr_read_alert[] = "[3][File read failed during|restore, restore not done.|][ CANCEL ]",
      writ_fail_alert[] = "[3][ERROR - Write failure on | primary or backup FAT.| ][ CANCEL ]",
      rstr_cmpl_alert[] = "[0][ | |Restore completed successfully. | |][ OK ]",
      copy_cmpl_alert[] = "[0][ | |FAT copied successfully.   | |][ OK ]";
                                   

/***********************************************************************
 *
 * GEM initialization.
 *
 ***********************************************************************/

prg_init()
{
int  counter;
long *ptr_tedinf;


appl_init();

v_opnvwk(work_in,&vdi_handle,work_out);

if (!rsrc_load("COMPRFAT.RSC"))              /* Load in resource file  */
     {
     form_alert(1,no_rsrc_alert);
     prg_exit();
     }
rsc_loaded = 1;

rsrc_gaddr(0,MAINTREE,&maintree);           /* Get addr of dial parents*/
rsrc_gaddr(0,DEVSTREE,&devstree);
rsrc_gaddr(0,INFOTREE,&infotree);

drv_bits = Drvmap() >> 2;
counter = 0;
while (drv_bits)
     {
     if (drv_bits & 0x00000001)
          objst_reset(devstree, DEVSBXC + counter++, DISABLED); 
     drv_bits >>= 1;
     }

graf_mouse(ARROW,0L);                       /* Set mouse to arrow.    */
}

/***********************************************************************
 *
 * Program cleanup and exit.
 *
 ***********************************************************************/

prg_exit()
{
if (p_membuf)                                /* If memory was alloc'ed */
     Mfree(p_membuf);                        /* free it.               */
if (rsc_loaded)
     rsrc_free();
v_clsvwk(vdi_handle);                        /* Close workstation.     */
appl_exit();                                 /* Say Goodbye to AES.    */
Pterm(0);                                    /* And get outta here.    */

}

/************************************************************************
 *
 * Object manipulations. (Get, Set, or Reset bit in state flag of obj).
 *
 ************************************************************************/

objst_set(tree, objindx, bit)
long tree;
int  objindx, bit;
{
int  cur_state;
cur_state = objst_get(tree, objindx);
( *((int *)(tree + objindx * sizeof(OBJECT) + 10)) = cur_state | bit);
}

objst_reset(tree, objindx, bit)
long tree;
int  objindx, bit;
{
int  cur_state;
cur_state = objst_get(tree, objindx);
( *((int *)(tree + objindx * sizeof(OBJECT) + 10)) = cur_state & ~bit);
}

objst_get(tree, objindx)
long tree;
int  objindx;
{
return( (int) *((int *)(tree + objindx * sizeof(OBJECT) + 10)) );
}

objfl_set(tree, objindx, bit)
long tree;
int  objindx, bit;
{
int  cur_flag;
cur_flag = objfl_get(tree, objindx);
( *((int *)(tree + objindx * sizeof(OBJECT) + 8)) = cur_flag | bit);
}

objfl_reset(tree, objindx, bit)
long tree;
int  objindx, bit;
{
int  cur_flag;
cur_flag = objfl_get(tree, objindx);
( *((int *)(tree + objindx * sizeof(OBJECT) + 8)) = cur_flag & ~bit);
}

objfl_get(tree, objindx)
long tree;
int  objindx;
{
return( (int) *((int *)(tree + objindx * sizeof(OBJECT) + 8)) );
}

/************************************************************************
 *
 * Handle a dialog, start to finish.  Return the index of the exit obj.
 *
 ************************************************************************/

dial_do(cur_tree,defindx)
long cur_tree;
int  defindx;
{
int         xdial, ydial, wdial, hdial, exitobj;
static int  xgrowpt = 0, ygrowpt = 0, wgrowpt = 0, hgrowpt = 0;

graf_mouse(M_OFF,0L);
form_center(cur_tree, &xdial, &ydial, &wdial, &hdial);
form_dial(0, xgrowpt, ygrowpt, wgrowpt, hgrowpt,
             xdial,   ydial,   wdial,   hdial);
form_dial(1, xgrowpt, ygrowpt, wgrowpt, hgrowpt,
             xdial,   ydial,   wdial,   hdial); 
objc_draw(cur_tree, R_TREE, MAX_DEPTH, xdial, ydial, wdial, hdial);
graf_mouse(M_ON,0L);
exitobj = form_do(cur_tree, defindx); 
graf_mouse(M_OFF,0L);
form_dial(2, xgrowpt, ygrowpt, wgrowpt, hgrowpt,
             xdial,   ydial,   wdial,   hdial); 
form_dial(3, xgrowpt, ygrowpt, wgrowpt, hgrowpt,
             xdial,   ydial,   wdial,   hdial); 
objst_reset(cur_tree, exitobj, SELECTED);
graf_mouse(M_ON,0L);
return(exitobj);
}

/****************************************************************
 *
 * Get the FATs from the input device. 
 *
 ***************************************************************/

load_fats(dev)
int  dev;
{
long min_bufsize;

p_bpb    = Getbpb(dev);                      /* Get the BPB            */
n_fatsec = p_bpb->b_fsiz;                    /* Get # of FAT sectors   */
min_bufsize = 512 * n_fatsec * 2;            /* Calc the min buf size  */
if (l_fatbuf < min_bufsize)                  /* If current buffer is   */
     {                                       /* too small...           */
     if (p_membuf)                           /* If there is even a cur */
          Mfree(p_membuf);                   /* buffer, free it. Then  */
     p_membuf = Malloc(min_bufsize);         /* get a bigger buffer.   */
     }

/* ------ Check for buffer allocation failure                   ------ */

if (p_membuf == 0L)
     {
     form_alert(1,no_mem_alert);
     prg_exit();
     }

/* ------ Read in both FATs from disk                           ------ */
if(Rwabs(0,p_membuf,(2 * n_fatsec),(p_bpb->b_fatrec - n_fatsec),dev))
     {
     form_alert(1,read_fail_alert);
     prg_exit();
     }

}

/****************************************************************
 *
 * put_fats - Dump the FATs from the memory buffer to the device,
 *   then force a media change on the device, then search for a
 *   dummy file (matters not whether we find it or don't), all 
 *   of this mickey-mouse will force GEMDOS to toss it's buffers,
 *   and realize that the data structures on the volume have 
 *   been raped.
 *
 ***************************************************************/


put_fats(drv_out)
int drv_out;
{
if(Rwabs(1,p_membuf,(2 * n_fatsec),(p_bpb->b_fatrec - n_fatsec),drv_out))
     {
     form_alert(1,writ_fail_alert);
     return(1);
     }

install_mediach();
Rwabs(0,0L,2,0,drv_out);
bkup_path[0] = drv_out + 'A';
Fsfirst(bkup_path,0);
deinstall_mediach();

return(0);
}

/****************************************************************
 *
 * Get the FATs from the input device, & compare them. If they 
 * are unequal, return 1, else return zero.
 *
 ***************************************************************/

do_fat_cmpr(dev)
int  dev;
{
register int *p_fat1, *p_fat2, counter;

load_fats(dev);

counter = 256 * n_fatsec;
p_fat1 = p_membuf;
p_fat2 = p_membuf + 256 * n_fatsec;
while (counter--)
     if (*p_fat1++ != *p_fat2++)
          return(1);
return(0);
}

/***************************************************************
 *
 * do_backup - Drive the logic to complete a backup. 
 *
 ***************************************************************/

do_backup()
{
int  drv_out;
long l_fats,l_written;

drv_in = get_dev(pr_bck1,pr_bck2);
if (drv_in < 0)
     return(0);
if (drv_in < 2)
     {
     form_alert(1,bkup_noab_alert);
     return(0);
     }

drv_out = form_alert(0,bkup_dev_alert);
if (drv_out > 2)
     return(0);
drv_out -= 1;
bkup_path[0] = 'A' + drv_out;
bkup_path[9] = 'A' + drv_in;

load_fats(drv_in);

fhandle = Fcreate(bkup_path,0);
if (fhandle < 0)
     {
     form_alert(1,bkup_fcre_alert);
     return(0);
     }

l_fats = n_fatsec * 512 * 2;
l_written = Fwrite(fhandle,l_fats,p_membuf);
Fclose(fhandle);
if (l_written != l_fats)
     {
     Fdelete(bkup_path);
     form_alert(1,bkup_fwrt_alert);
     }
else
     form_alert(1,bkup_cmpl_alert);
}

/***************************************************************
 *
 * do_restore - Drive the logic to complete a restore.
 *
 ***************************************************************/

do_restore()
{
int  drv_out;
long l_fats,l_read;

drv_out = get_dev(pr_rst1,pr_rst2);
if (drv_out < 0)
     return(0);
if (drv_out < 2)
     {
     form_alert(1,bkup_noab_alert);
     return(0);
     }

drv_in = form_alert(0,rstr_dev_alert);
if (drv_in > 2)
     return(0);
drv_in -= 1;
bkup_path[0] = 'A' + drv_in;
bkup_path[9] = 'A' + drv_out;

load_fats(drv_out); /* make sure the buffer is big enough, prime bpb */

fhandle = Fopen(bkup_path,0);
if (fhandle < 0)
     {
     form_alert(1,rstr_open_alert);
     return(0);
     }

l_fats = n_fatsec * 512 * 2;
l_read = Fread(fhandle,l_fats,p_membuf);
Fclose(fhandle);
if (l_read != l_fats)
     {
     form_alert(1,rstr_read_alert);
     }
else
     {
     if (!put_fats(drv_out));
          form_alert(1,rstr_cmpl_alert);
     }
}

/***************************************************************
 *
 * do_fatcopy- copy primary to backup FAT.
 *
 ***************************************************************/

do_fatcopy(code)
int  code;
{
register int *p_fat1, *p_fat2, counter;
int drv;

if (code == MAINBXPB)
     drv = get_dev(pr_p2b1,pr_p2b2);
else
     drv = get_dev(pr_b2p1,pr_b2p2);

if (drv < 0)
     return(0);

load_fats(drv);

counter = 256 * n_fatsec;
if (code == MAINBXPB)
     {
     p_fat1 = p_membuf;
     p_fat2 = p_membuf + 256 * n_fatsec;
     }
else
     {
     p_fat2 = p_membuf;
     p_fat1 = p_membuf + 256 * n_fatsec;
     }

while (counter--)
     *p_fat2++ = *p_fat1++;

if(!put_fats(drv))
     form_alert(1,copy_cmpl_alert);
}


/***************************************************************
 *
 * get_dev - Ask the user for a device.
 *
 ***************************************************************/

get_dev(prompt1,prompt2)
char *prompt1,*prompt2;
{
int  selection;

(*((long *)(devstree + (DEVSSTR1  * sizeof(OBJECT)) + 12))) = prompt1;
(*((long *)(devstree + (DEVSSTR2  * sizeof(OBJECT)) + 12))) = prompt2;

selection = dial_do(devstree,0);
if (selection == DEVSBXCN)
     return(-1);
return(selection - DEVSBXA);
}


/****************************************************************
 *
 * Main routine.
 *
 ***************************************************************/

main()
{
int selection;

prg_init();

while (1)
     {
     selection = dial_do(maintree,0);
     switch (selection)
     {
          case MAINBXEX:
               prg_exit();
          case MAINBXHE:
               dial_do(infotree,0);
               break;
          case MAINBXCP:
               drv_in = get_dev(pr_cmp1,pr_cmp2); 
               if (drv_in >= 0)
                    {
                    if (do_fat_cmpr(drv_in))
                         form_alert(1,cmpr_fail_alert);
                    else
                         form_alert(1,cmpr_good_alert);
                    }
               break;
          case MAINBXBU:
               do_backup();
               break;
          case MAINBXRS:
               do_restore();
               break;
          case MAINBXPB:
          case MAINBXBP:
               do_fatcopy(selection);
               break;
          } /* END switch(selection) */
     } /* END while(1) */
}
