/*OPTIC shell*/
/*Version 1.00*/
/*by Saveen V. Reddy*/
/*Public Domain*/

#include	<osbind.h>
#include	<stdio.h>
#include	<strings.h>
#include	<math.h>

#define	AND	&&
#define	OR	||

/*these defines we use to tell what kinf of file we are dealing with*/
#define READONLY 1
#define HIDDEN 2
#define SYSTEM 4
#define VOLUME 8
#define FOLDER 16
#define WRITECLOSED 32

#define ALL_FILES 33	/*Search value for Fsfirst() for normal files*/

#define	NUM_WORDS	11	/*Number of words to parse for can be changed with no problems*/
#define	NUM_MACROS	10	/*Number of macros code must be rewritten if this is changed*/
#define	SLENGTH	128	/*Standrad length of a string*/
#define BATCH_SIZE 4096L	/*Size allocated for storing a batch file*/
#define NUM_BATCH 3		/*Number of batch files that can be run at one time*/

int	dummy,	/*Misc. GEM junk*/
	phys_handle,
	handle,
	contrl[12], intin[128], ptsin[128], intout[128], ptsout[128],
	work_in[11]={1,1,1,1,1,1,1,1,1,1,2}, work_out[57];

int	finished=0,yes=1,no=0,drive,rez,
	word_loc[NUM_WORDS],	/*position of the words in string*/
	delim_loc[NUM_WORDS],	/*position of delimiters*/
	found,	/*if command was found it =yes otherwize =no*/
	word_count,	/*number of words found in string*/
	batch_stat=0;	/*number of batch files being run*/

long	old_dta;	/*Address of old DTA*/
long	_stksize=16000L;	/*Set up a new stacksize*/

/*needed for using floating point math*/
double math_var=0;
extern double atof();

char	path[SLENGTH],
		zline[SLENGTH],	/*the line typed by the user*/
		command[SLENGTH],	/*capatilized version of zline[]*/
		word[NUM_WORDS][SLENGTH],	/*the actual strings containing the words*/
		variable[10][SLENGTH],	/*the variable strings*/
		macro[NUM_MACROS][SLENGTH],	/*the macro strings*/
		macro_name[NUM_MACROS][SLENGTH];	/*name of the macros*/

char	all_extensions[]="\\*.*";

/*our own DTA structure definition*/
typedef struct {
	char reserved[21];
	char attribute;
	int ftime;
	int fdate;
	long fsize;
	char fname[14];
} DTA;

DTA new_dta;

main()
{
	int ox,oy;

	application(1);
	puts("OPTIC SHELL");
	puts("version 1.00");
	puts("by Saveen V. Reddy");
	puts("If you have any complaints or suggestions tell me (RHODAN)\n\n");
	while (finished==no) {
		crsrgetpos(&ox,&oy);
		crsrsetpos(0,oy);
		erase_stuff();
		if (rez!=2) crsrcolor(3,0);
		drive=Dgetdrv();
		Cconout(drive+65);
		Cconout('>');
		getline(zline,77);
		if (rez!=2) crsrcolor(1,0);
		Cconout(10);
		Cconout(13);
		stuff_variables();
		strcpy(command,zline);
		str_t_upper(command);
		check_macros();
		word_count=parse(zline,NUM_WORDS,word_loc,delim_loc);
		fill_words();
		if (word_count>0) {
			found=no;
			find_command();
			if (found==no) check_drive();
			if (found==no) check_files();
			if (found==no) printf("\tThere was no such command as %s\n",word[0]);
		}
	}
	application(0);
}

ascii_chart()
{
	int x,counter=0,key;

	found=yes;
	for(x=atoi(word[1]);x<256;x++) {
		Cconout(32);
		Bconout(5,x);
		printf("\t ASCII: %3d    Hex: %2x ",x,x);
		if ((x>=0) AND (x<=0x1f)) {
			printf("control ");
			if ((x>=0x1) AND (x<=0x1d)) printf("%c ",x+64);
			if (x==0) printf("2 (NULL) ");
			if (x==0x1e) printf("6 ");
			if (x==0x1f) printf("- ");
		}
		if (x==0x20) printf("space ");
		if (x==0x5f) printf("underscore ");
		if (x==0x75) printf("rubout (DELETE key) ");
		puts(" ");
		counter++;
		if (counter>20) {
			counter=0;
			v_rvon(handle);
			puts("\tPress SPACE BAR to continue or ESCAPE to QUIT");
			v_rvoff(handle);
			key=Crawcin();
			if (key==27) break;
		}
	}
}

binary_command()
{
	int x;
	unsigned long value;
	unsigned long bin_val[32];

	found=yes;
	if (word_count>=2) {
		bin_val[0]=1;
		puts("332222222222111111111");
		puts("10987654321098765432109876543210");
		puts("       *       *       *       *");
		for (x=1;x<32;x++) bin_val[x]=bin_val[x-1]*2;
		value=(long)atol(word[1]);
		for (x=0;x<32;x++) {
			if (value>=bin_val[31-x]) {
				Cconout('1');
				value-=bin_val[31-x];
			}
			else Cconout('0');
		}
		puts(" ");
	}
	else puts("needs a decimal value to show as binary value");
}

bye()
{
	int key;

	found=yes;
	puts("\tDo you really want to quit (Y/N)");
	key=Crawcin();
	if ((key=='y') OR (key=='Y')) finished=yes;

}

cls_command()
{
	found=yes;
	crsrcls();
}

copy()
{
	int	sh,dh,der,fnd,x,key,length,ss=0,sm=0,ds=0,dd=0,cut=no;
	long	br,bw,buffer;
	char	sn[SLENGTH],dn[SLENGTH],sf[SLENGTH],df[SLENGTH];

	found=yes;
	if (word_count<3) {
		if (word_count==1) {
			if (!find_file(all_extensions,word[1],"COPY source file")) return;
			if (!find_file(all_extensions,word[2],"COPY destination file")) return;
		}
		if (word_count==2) {
			if (!find_file(all_extensions,word[2],"COPY destination file")) return;
		}
	}
	strcpy(sf,word[1]);
	strcpy(df,word[2]);
	fnd=Fsfirst(sf,ALL_FILES);
	if (fnd>=0) {
		fnd=Fsnext();
		if (fnd>=0) sm=1;
		else ss=1;
	}
	else {
		puts("\tNo files found to copy");
		return;
	}
	fnd=df[strlen(df)-1];
	if ((fnd=='\\') OR (fnd==':')) dd=1;
	else ds=1;
	if ((sm==1) AND (ds==1)) {
		puts("\tCannot copy multiple files to single destination");
		return;
	}

	buffer=Malloc(16001L);
	if (buffer<1) {
		puts("\tProgram could not allocate 16K for copy");
		return;
	}
	Fsetdta(&new_dta);
	fnd=Fsfirst(sf,ALL_FILES);
	puts(" ");
	while(fnd>=0) {
		if (Cconis()!=0) {
			key=Crawcin();
			if (key==27) {
				puts("\tCOPY command was cancelled by user");
				break;
			}
		}
		length=strlen(sf);
		for(x=length;x>=0;x--) {
			if ( (sf[x]=='\\') OR (sf[x]==':') ) {
				sf[x+1]=0;
				cut=yes;
				break;
			}
		}
		strcpy(sn,sf);
		if (cut==yes) strcat(sn,new_dta.fname);
		strcpy(dn,df);
		if (dd==1) {
			length=strlen(dn);
			for(x=length;x>=0;x--) {
				if ( (dn[x]=='\\') OR (dn[x]==':') ) {
					dn[x+1]=0;
					break;
				}
			}
			strcat(dn,new_dta.fname);
		}
		sh=Fopen(sn,0);
		if (sh<0) {
			disk_error(sh);
			break;
		}
		if (ds==1) strcpy(dn,df);
		dh=Fcreate(dn,0);
		if (dh<0) {
			disk_error(dh);
			break;
		}
		br=1;
		printf("\tCopying: %s\n",new_dta.fname);
		while(br>0) {
			br=Fread(sh,16000L,buffer);
			if (br<1) break;
			bw=Fwrite(dh,br,buffer);
			if (bw<1) break;
		}
		Fclose(sh);
		Fclose(dh);
		fnd=Fsnext();
		if (ds==1) break;
		if (ss==1) break;
	}
	Fsetdta(old_dta);
	Mfree(buffer);
}

cprnout_command()
{
	int value;

	found=yes;
	if (word_count>1) {
		value=atoi(word[1]);
		if ((value<0) OR (value>255)) {
			puts("\tCan't send improper value");
			return;
		}
		Cprnout(value);
	}
	else puts("\tCommand needs value of byte to send to printer");
}

date()
{
	int day,month,year;
	dateinfo xdate;

	found=yes;
	xdate.realdate=Tgetdate();
	if (word_count>=4) {
		month=atoi(word[1]);
		day=atoi(word[2]);
		year=atoi(word[3]);
		xdate.part.month=month;
		xdate.part.day=day;
		xdate.part.year=year;
		Tsetdate(xdate.realdate);
	}
	else printf("\tSystem date: %2d-%02d-%d\n",xdate.part.month,xdate.part.day,xdate.part.year);
}

decimal_command()
{
	long num_1;

	found=yes;
	if (word_count>=2) {
		num_1=strtol(word[1],(char **)NULL,16);
		printf("\tDecimal value: %ld\n",num_1);
	}
	else puts("\tNeeds a hex number");
}

delete()
{
	int	fnd,der,key;

	found=yes;
	if (word_count<2) {
		if (!find_file(all_extensions,word[1],"DELETE file")) return;
	}
	Fsetdta(&new_dta);
	der=Fsfirst(word[1],ALL_FILES);
	if (der<0) {
		disk_error(der);
		return;
	}
	while(Fsfirst(word[1],ALL_FILES)>=0) {
		if (Cconis()!=0) {
			key=Crawcin();
			if (key==27) {
				puts("\tDELETE command was cancelled by user");
				break;
			}
		}
		printf("\tDeleting: %s\n",new_dta.fname);
		der=Fdelete(word[1]);
		if (der<0) {
			disk_error(der);
			break;
		}
	}
	Fsetdta(old_dta);
}


dd()
{
	int	fnd,cx=0,cy=0,space,lcount=0,x,xlen,choice,key;
	int file_count=0,fold_count=0;
	int pxy[4];
	char	size[10],xpath[SLENGTH],string[SLENGTH];

	found=yes;
	Fsetdta(&new_dta);
	get_dir_path();
	crsrcls();
	fnd=Fsfirst(path,SYSTEM+FOLDER+HIDDEN+READONLY+WRITECLOSED);
	while (fnd>=0) {
		lcount++;
		crsrsetpos(cx*27,cy);
		if (new_dta.attribute & FOLDER) {
			v_rvon(handle);
			Bconout(5,7);
			fold_count++;
		}
		else file_count++;

		if (new_dta.attribute & HIDDEN) Bconout(5,8);
		else {
			if (new_dta.attribute & SYSTEM) Bconout(5,127);
			else {
				if (new_dta.attribute & READONLY) Bconout(5,42);
				else Cconout(32);
			}
		}
		sprintf(string,"%13s",new_dta.fname);
		Cconws(string);
		if (new_dta.attribute & FOLDER) v_rvoff(handle);
		else {
			sprintf(size,"%10.9lu",new_dta.fsize);
			Cconws(size);
		}
		cy++;
		if (cy>20) {
			cy=0;
			cx++;
			if (cx>2) {
				Cconout(10);
				Cconout(13);
				v_rvon(handle);
				puts("\tPress SPACE BAR to continue, ESCAPE to exit");
				v_rvoff(handle);
				key=Crawcin();
				if (key==27) break;
				crsrcls();
				cx=0;
			}
		}
		fnd=Fsnext();
	}
	Fsetdta(old_dta);
	if (cx==0) crsrsetpos(0,lcount+2);
	else crsrsetpos(0,22);
	puts("------------------------------------------------------------------------------");
	printf("\tFiles: %d   Folders: %d\n",file_count,fold_count);
}

dir()
{
	int fnd,der,fold_count=0,file_count=0,xcount=0,key;
	char fold_name[SLENGTH];

	dateinfo x_date;
	timeinfo x_time;

	found=yes;
	Fsetdta(&new_dta);
	get_dir_path();
	der=Fsfirst(path,READONLY+FOLDER+WRITECLOSED);
	while(der>=0) {
		x_time.realtime=new_dta.ftime;
		x_date.realdate=new_dta.fdate;
		if (new_dta.attribute & FOLDER) {
			v_rvon(handle);
			sprintf(fold_name," %-14.14s          ",new_dta.fname);
			Cconws(fold_name);
			v_rvoff(handle);
			fold_count++;
		}
		else {
			if (new_dta.attribute & READONLY) Cconout('*');
			else Cconout(32);
			printf("%-14.14s  %8ld",new_dta.fname,new_dta.fsize);
			file_count++;
		}
		printf(" %2d-%02d-%4d  %2d:%02d\n",x_date.part.month,x_date.part.day,x_date.part.year+1980,x_time.part.hours,x_time.part.minutes);
		xcount++;
		if (xcount>20) {
			xcount=0;
			v_rvon(handle);
			puts("\tPress SPACE BAR to continue, ESCAPE to exit");
			v_rvoff(handle);
			key=Crawcin();
			if (key==27) break;
		}
		der=Fsnext();
	}
	Fsetdta(old_dta);
	puts("-------------------------------------------");
	printf("\tFiles: %d  Folders: %d\n",file_count,fold_count);
}

disk()
{
	disk_info xinfo;

	found=yes;
	drive=Dgetdrv()+1;
	Dfree(&xinfo,drive);
	printf("\tDisk information about drive %c:\n",drive+64);
	printf("\tfree clusters: %ld\n",xinfo.b_free);
	printf("\ttotal clusters: %ld\n",xinfo.b_total);
	printf("\tbytes per sector: %ld\n",xinfo.b_secsiz);
	printf("\tsectors per cluster: %ld\n",xinfo.b_clsiz);
	printf("\n\tfree bytes: %ld\n",xinfo.b_free*xinfo.b_clsiz*xinfo.b_secsiz);
}

examine_file()
{
	int fh,key;
	long br,line_count=0,counter=0;
	char value;

	found=yes;
	if (word_count<2) {
		if (!find_file(all_extensions,word[1],"EXAMINE filename")) return;
	}
	fh=Fopen(word[1],0);
	if (fh>=0) {
		br=1;
		while(br>0) {
			br=Fread(fh,1L,&value);
			if (br>0) {
				counter++;
				line_count++;
				printf("\t%ld : (hex) %x\n",counter,value,(int)value);
				if (line_count>20) {
					v_rvon(handle);
					puts("\tPress SPACE BAR to continue,ESCAPE to quit");
					v_rvoff(handle);
					key=Crawcin();
					if (key==27) break;
					line_count=0;
					crsrcls();
				}
			}
		}
		Fclose(fh);
	}
	else disk_error(fh);
}

create_file()
{
	int done=no;
	int der;
	char type_line[SLENGTH];

	FILE *fp;

	found=yes;
	if (word_count<2) {
		if (!find_file(all_extensions,word[1],"FILE select filename to create")) return;
	}
	fp=fopen(word[1],"w");
	if (fp) {
		puts("\tFile opened successfully");
		puts("\tType an empty line to close file");
		while(done==no) {
			Cconout('>');
			getline(type_line,78);
			Cconout(10);
			Cconout(13);
			if (strlen(type_line)==0) break;
			der=fputs(type_line,fp);
			if (der!=EOF) fputc(10,fp);
			if (der==EOF) {
				puts("\tError while writing to file");
				break;
			}
		}
		fclose(fp);
	}
	else puts("\tError trying to open file");
}

format_command()
{
	int choice=(-1),sides=1,sideno=0,key,sectno=1,sectors=9;
	int trackno,i,disk_type=2,stat,ox,oy;
	long magic=0x87654321L,serialno=0x1000000L;
	char buf[10240];

	found=yes;
	drive=0;
	if (word_count<2) return;
	else {
		if (strcmp(word[1],"AS")==0) choice=0;
		if (strcmp(word[1],"AD")==0) choice=1;
		if (strcmp(word[1],"BS")==0) choice=2;
		if (strcmp(word[1],"BD")==0) choice=3;
		if (choice<0) {
			puts("\tImproper parameter.  Format canceled");
			return;
		}
	}
	if ((choice==0) OR (choice==1)) drive=0;/*Drive A*/
	if ((choice==2) OR (choice==3)) drive=1;/*Drive B*/
	if ((choice==0) OR (choice==2)) sides=1;/*Single Sided*/
	if ((choice==1) OR (choice==3)) {
		sides=2;/*Double Sided*/
		disk_type=3;
	}

	printf("\tFormatting drive %c ",drive+'A');
	if ((choice==1) OR (choice==3)) puts("\tDouble Sided");
	else puts("\tSingle Sided");
	puts("\tInsert disk you want to format in drive");
	puts("\tPress RETURN key to continue");
	puts("\tPress ANY OTHER KEY to stop at this point");
	key=Crawcin();
	if (key!=13) return;
	puts("\n\n");
	v_curup(handle);
	crsrgetpos(&ox,&oy);
	for (sideno=0;sideno<sides;sideno++) {
			for (trackno=0;trackno<80;trackno++) {
				crsrsetpos(ox,oy);
				printf("\tFormatting side: %d  track: %d    \n",sideno,trackno);
				stat=Flopfmt(buf,0L,drive,sectors,trackno,sideno,1,magic,0xe5e5);
				if (stat) {
					puts("\tError while formatting");
					return;
				}
			}
	}
	puts("\n\tCreating Boot Blocks");
	bzero(buf,10240);
	for (sideno=0;sideno<sides;sideno++) {
		for (trackno=0;trackno<2;trackno++ ) {
			stat=Flopwr(buf,0L,drive,1,trackno,sideno,sectors);
			if (stat) {
				puts("\tError creating boot blocks");
				return;
			}
		}
	}
	Protobt(buf,(long)Random(),disk_type,0);
	Flopwr(buf,0L,drive,1,0,0,1);
	Flopver(buf,0L,drive,1,0,0,1);
}

help()
{
	found=yes;
	if (word_count>1) {
		if (strcmp(word[1],"ASCII")==0) {
			puts("\tShow a list of all the ASCII (0-255) characters on screen");
			puts("\tformat:");
			puts("\t\tASCII decimal_value(0-255)");
			puts("\texample:");
			puts("\t\tASCII 15");
			puts("note: if no argument is given it starts at zero");
		}

		if ((strcmp(word[1],"BYE")==0) OR (strcmp(word[1],"EXIT")==0) OR (strcmp(word[1],"BYE")==0)) {
			puts("\tExit the shell");
		}
		if (strcmp(word[1],"CLS")==0) {
			puts("\tClear screen and put cursor in home position");
		}
		if (strcmp(word[1],"COPY")==0) {
			puts("\tCopy file(s)");
			puts("\tformat:");
			puts("\t\tCOPY filename filename");
			puts("\t\tCOPY filename path");
			puts("\t\tCOPY path path");
			puts("\texamples:");
			puts("\t\tCOPY a:\\x.dat a:\\z.dat");
			puts("\t\tCOPY a:\\x.dat a:\\folder\\");
			puts("\t\tCOPY a:\\folder1\\*.* a:\\folder12\\");
		}
		if (strcmp(word[1],"CP")==0) {
			puts("\tCP is an abbreviation for COPY");
			puts("\ttype HELP COPY to see info");
		}
		if (strcmp(word[1],"CPRNOUT")==0) {
			puts("\tSend a byte to printer port");
			puts("\tformat:");
			puts("\t\tCPRNOUT decimal_byte");
			puts("\texample");
			puts("\t\tCPRNOUT 12");
		}
		if (strcmp(word[1],"DATE")==0) {
			puts("\tGet/set system date");
			puts("\tformat:");
			puts("\t\tDATE");
			puts("\t\tDATE month day year");
			puts("\texample:");
			puts("\t\tDATE");
			puts("\t\tDATE 10 6 1988");
		}
		if (strcmp(word[1],"DEC")==0) {
			puts("\tshow decimal version of hex number");
			puts("\tformat:");
			puts("\t\tDEC hex_number");
			puts("\texample:");
			puts("\t\tDEC FF00");
		}
		if (strcmp(word[1],"DELETE")==0) {
			puts("\tDelete file(s)");
			puts("\tformat");
			puts("\t\tDELETE filename");
			puts("\t\tDELETE path");
			puts("\texample:");
			puts("\t\tDELETE x.dat");
			puts("\t\tDELETE *.txt");
		}
		if (strcmp(word[1],"DEL")==0) {
			puts("\tDEL is abbreviation for DELETE");
			puts("type HELP DELETE to see info");
		}
		if (strcmp(word[1],"DD")==0) {
			/*	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	*/
			puts("\tShow a disk directory that contains every type of file, even hidden");
			puts("\t or system files.  Only the filename and its length is shown.");
			puts("\tformat:");
			puts("\t\tDD path");
			puts("\texample:");
			puts("\t\tDD *.TXT*");
		}
		if (strcmp(word[1],"DIR")==0) {
			puts("\tshow disk directory");
			puts("\tformat:");
			puts("\t\tDIR path");
			puts("\texample:");
			puts("\t\tDIR *.*");
		}
		if (strcmp(word[1],"D")==0) {
			puts("\tD is an abbreviation for DIR");
			puts("\ttype HELP DIR to see info");
		}
		if (strcmp(word[1],"DISK")==0) {
			puts("\tshows information about disk drive");
			puts("\tthe disk in question is the default drive");
		}
		if (strcmp(word[1],"EXAMINE")==0) {
			puts("\tShow hex dump of file on screen");
			puts("\tformat:");
			puts("\t\tEXAMINE filename");
			puts("\texample:");
			puts("\t\tEXAMINE sample.dat");
		}

		if (strcmp(word[1],"FILE")==0) {
			puts("\tcreate and ascii file line bye line");
			puts("\tformat:");
			puts("\t\tFILE filename");
			puts("\texample:");
			puts("\t\tFILE x.txt");
		}

		if (strcmp(word[1],"FORMAT")==0) {
			puts("\tformat a disk");
			puts("\tformat:");
			puts("\t\tFORMAT argument:");
			puts("\t\tpossible arguments are");
			puts("\t\tdrive A single sided - AS");
			puts("\t\tdrive A double sided - AD");
			puts("\t\tdrive B single sided - BS");
			puts("\t\tdrive B double sided - BD");
			puts("\texample:");
			puts("\t\tFORMAT AD");
		}


		if ((strcmp(word[1],"HELP")==0) OR (strcmp(word[1],"?")==0)) {
			puts("\tTo run a program or batch file:");
			puts("\ttype the filename (including extender) and any arguments\n");
			puts("\tTo change default drive:");
			puts("\tType drive letter and then colon ( A: , B: )\n");
			puts("\tVariables contain the arguments to batch files\n");
			puts("\tUp to 3 batch files can be run at the same time\n");
			puts("\t NOTE: every time a new batch file is called with");
			puts("\targuments, the variables are cleared for the new one\n");
			puts("\tmultiple arguments are not seperated by commas\n");
			puts("\tTo execute a macro type its name");
		}

		if (strcmp(word[1],"HEX")==0) {
			puts("\tDisplay hexadecimal version of decimal number");
			puts("\tformat:");
			puts("\t\tHEX decimal_number");
			puts("\texample:");
			puts("\t\tHEX 256");
		}

		if (strcmp(word[1],"HIDE")==0) {
			puts("\tSet file to hidden status");
			puts("\tformat:");
			puts("\t\tHEX filename");
			puts("\texample:");
			puts("\t\tHIDE x.dat");
			puts("\t NOTE: hidden files can be displayed through the DD command");
		}


		if (strcmp(word[1],"IF")==0) {
			puts("\tExecutes a statement if a condition is met");
			puts("\tformat:");
			puts("\t\tIF EXISTS filename statement");
			puts("\t\tIF NOTEXISTS filename statement");
			puts("\t\tIF FOLDER foldername statement");
			puts("\t\tIF NOTFOLDER foldername statement");
			puts("\t\tIF item = item statement");
			puts("\t\tIF item != item statement");
			puts("\texamples:");
			puts("\t\tIF EXISTS sample.dat text yes it works");
			puts("\t\tIF NOTEXISTS sample.dat text NO it doesn't work");
			puts("\t\tIF FOLDER a:\\folder text hell yeah it is a folder");
			puts("\t\tIF NOTFOLDER a:\\folder text no I can't see it");
			puts("\t\tIF %0 = %1 text they are equal");
			puts("\t\tIF %0 = Hello text he said Hi!");
			puts("\t\tIF %0 != %1 text no no no no not equal");
		}

		if (strcmp(word[1],"IOREC")==0) {
			puts("\tShow information about an I/O buffer");
			puts("\tformat:");
			puts("\t\tIOREC argument");
			puts("\t\tpossible arguments are");
			puts("\t\trs232");
			puts("\t\tkeyboard");
			puts("\t\tmidi");
			puts("\texamples:");
			puts("\t\tIOREC rs232");
			puts("\t\tIOREC keyboard");
			puts("\t\tIOREC midi");
		}

		if (strcmp(word[1],"KEYCODE")==0) {
			puts("\tShow scan codes for any key");
		}


		if (strcmp(word[1],"MACRO")==0) {
			puts("\tGet/Set macros");
			puts("\tformat:");
			puts("\t\tto see all macros:");
			puts("\t\t\tMACRO");
			puts("\t\tto clear all macros");
			puts("\t\t\tMACRO CLEAR");
			puts("\t\tto clear a certain macro");
			puts("\t\t\tMACRO macro_number(0-9)");
			puts("\t\tto set a macro");
			puts("\t\t\tMACRO macro_number(0-9) macro_name string");
			puts("\texample");
			puts("\t\tMACRO 0 look_for dir *.txt*");
		}

		if (strcmp(word[1],"MACROLOAD")==0) {
			puts("\tLoad a macro file");
			puts("\tformat:");
			puts("\t\tMACROLOAD filename");
			puts("\texample:");
			puts("\t\tMACROLOAD x.mac");
		}

		if (strcmp(word[1],"MACROSAVE")==0) {
			puts("\tSave a macro file");
			puts("\tformat:");
			puts("\t\tMACROSAVE filename");
			puts("\texample:");
			puts("\t\tMACROSAVE x.mac");
		}

		if (strcmp(word[1],"MKDIR")==0) {
			puts("\tCreate a folder");
			puts("\tformat");
			puts("\t\tMKDIR folder_name");
			puts("\texample:");
			puts("\t\tMKDIR a:\folder");
		}

		if (strcmp(word[1],"PATH")==0) {
			puts("\tGet/Set path");
			puts("\tformat:");
			puts("\t\tPATH");
			puts("\t\tPATH SET pathname");
			puts("\texample:");
			puts("\t\tPATH");
			puts("\t\tPATH SET A:\\FOLDER\\");
		}

		if (strcmp(word[1],"PAUSE")==0) {
			puts("\tForce user to press a key to continue");
		}

		if (strcmp(word[1],"POS")==0) {
			puts("\tPlace the cursor at position");
			puts("\tthe upper left corner is 0,0");
			puts("\tformat");
			puts("\t\tPOS x y");
			puts("\texample:");
			puts("\t\tPOS 10 1");
		}

		if (strcmp(word[1],"PRINT")==0) {
			puts("\tSend file to printer");
			puts("\tformat:");
			puts("\t\tPRINT filename");
			puts("\texample:");
			puts("\t\tPRINT x.txt");
		}

		if (strcmp(word[1],"PROTECT")==0) {
			puts("\tSet file to protected status");
			puts("Use UNPROTECT to set protect file to normal");
			puts("\tformat:");
			puts("\t\tPROTECT filename");
			puts("\texample:");
			puts("\t\tPROTECT x.txt");
		}

		if (strcmp(word[1],"REN")==0) {
			puts("REN is an abbreviation of RENAME");
			puts("type HELP RENAME to see info");
		}

		if (strcmp(word[1],"RENAME")==0) {
			puts("\tRename file");
			puts("\tformat:");
			puts("\t\tRENAME old_filename new_filename");
			puts("\texample:");
			puts("\t\tRENAME x.txt abc.txt");
		}

		if (strcmp(word[1],"RMDIR")==0) {
			puts("\tDelete a folder");
			puts("\tformat");
			puts("\t\tRMDIR folder_name");
			puts("\texample:");
			puts("\t\tRMDIR a:\folder");
		}


		if (strcmp(word[1],"SCREEN")==0) {
			puts("\tShow the logical and physical address of screen");
		}


		if (strcmp(word[1],"SQR")==0) {
			puts("\tFind the square of the value in the math variable value");
			puts("\tthe math variable will then be that value");
			puts("\texample:");
			puts("\t\tSQR");
		}

		if (strcmp(word[1],"SQRT")==0) {
			puts("Find the square root of the value in the math variable value");
			puts("the math variable will then be that value");
			puts("\texample:");
			puts("\t\tSQRT");
		}

		if (strcmp(word[1],"SET")==0) {
			puts("\tShow or set the variables");
			puts("\tto show variables:");
			puts("\t\tSET");
			puts("\tto set variable:");
			puts("\t\tSET variable_number(don't include %) expression");
			puts("\texample:");
			puts("\t\tSET 0 YabbaDabbadoo");
		}

		if (strcmp(word[1],"SYSTEM")==0) {
			puts("\tSet a file to system status");
			puts("\tformat:");
			puts("\t\tSYSTEM filename");
			puts("\texample:");
			puts("\t\tSYSTEM x.dat");
		}


		if (strcmp(word[1],"TEXT")==0) {
			puts("\tWrite out text to the screen");
			puts("\tUse POS to set a position to print at");
			puts("\tformat:");
			puts("\t\tTEXT string");
			puts("\texample:");
			puts("\t\tTEXT A line of text");
		}


		if (strcmp(word[1],"TIME")==0) {
			puts("\tGet/set time");
			puts("\tTIME command uses 0:00 - 23:00 system of time");
			puts("\tto show time:");
			puts("\t\tTIME");
			puts("\tto set time:");
			puts("\t\tTIME hour minute");
			puts("example:");
			puts("\t\tTIME 11 51");
		}


		if (strcmp(word[1],"TOUCH")==0) {
			puts("Set file date/time stamp to system date/time");
			puts("\tformat:");
			puts("\t\tTOUCH filename");
			puts("example:");
			puts("TOUCH x.dat");
		}



		if (strcmp(word[1],"UNHIDE")==0) {
			puts("\tSet a hidden file to unhidden status");
			puts("\tformat:");
			puts("\t\tUNHIDE filename");
			puts("\texample:");
			puts("\t\tUNHIDE x.dat");
		}

		if (strcmp(word[1],"UNPROTECT")==0) {
			puts("\tSet a protected file to unprotected status");
			puts("\tformat:");
			puts("\t\tUNPROTECT filename");
			puts("\texample:");
			puts("\t\tUNPROTECT x.dat");
		}

		if (strcmp(word[1],"UNSYSTEM")==0) {
			puts("\tSet a system file to unsystem status");
			puts("\tformat:");
			puts("\t\tUNSYSTEM filename");
			puts("\texample:");
			puts("\t\tUNSYSTEM x.dat");
		}


		if (strcmp(word[1],"UNTOUCH")==0) {
			puts("\tSet system date/time to file's date/time");
			puts("\tformat:");
			puts("\t\tUNTOUCH filename");
			puts("\texample:");
			puts("\t\tUNTOUCH x.dat");
		}


		if (strcmp(word[1],"VBOX")==0) {
			puts("\tDraw a VDI box");
			puts("\tformat:");
			puts("\t\tVBOX x1 y1 x2 y2");
			puts("\texample:");
			puts("\t\tVBOX 0 0 100 100");
		}


		if (strcmp(word[1],"VCOLOR")==0) {
			puts("\tSet draw color for all VDU functions");
			puts("\tformat:");
			puts("\t\tVCOLOR color");
			puts("\texample:");
			puts("\t\tVCOLOR 4");
		}


		if (strcmp(word[1],"VERSION")==0) {
			puts("Show TOS version number");
		}


		if (strcmp(word[1],"VFRAME")==0) {
			puts("\tDraw a VDI frame");
			puts("\tformat:");
			puts("\t\tVFRAME x1 y1 x2 y2");
			puts("\texample:");
			puts("\t\tVFRAME 0 0 100 100");
		}


		if (strcmp(word[1],"VLINE")==0) {
			puts("\tDraw a VDI line");
			puts("\tformat:");
			puts("\t\tVLINE x1 y1 x2 y2");
			puts("\texample:");
			puts("\t\tVLINE 0 0 100 100");
		}


		if (strcmp(word[1],"VIEW")==0) {
			puts("Show ASCII file on screen");
			puts("\tformat:");
			puts("\t\tVIEW filename");
			puts("example:");
			puts("VIEW readme.doc");
		}


		if (strcmp(word[1],"BREAK")==0) {
			puts("Stop execution of batch file");
			puts("Works only if called from a batch file");
		}


		if (strcmp(word[1],"+")==0) {
			puts("Add a value to the math variable value");
			puts("example:");
			puts("+ 15");
		}


		if (strcmp(word[1],"-")==0) {
			puts("Subtract a value to the math variable value");
			puts("example:");
			puts("- 15");
		}


		if (strcmp(word[1],"*")==0) {
			puts("Multiply a value to the math variable value");
			puts("example:");
			puts("* 15");
		}


		if (strcmp(word[1],"/")==0) {
			puts("Divide a value to the math variable value");
			puts("example:");
			puts("/ 15");
		}
		return;
	}
	puts("\t\t\tHELP MENU");
	puts("----------------------------------------------------------------------");
	puts("ASCII     BYE       CLS       COPY      CP        CPRNOUT");
	puts("DATE      DEC       DEL       DELETE    D         DIR       DD");
	puts("DISK      EXAMINE   EXIT      FILE      FORMAT    HELP      ?");
	puts("HEX       HIDE      IF        IOREC     KEYCODE   MACRO     MACROLOAD");
	puts("MACROSAVE PATH      PAUSE     POS       PRINT     PROTECT   MKDIR");
	puts("QUIT      REN       RENAME    RMDIR     SCREEN    SQR       SQRT");
	puts("SET       SYSTEM    TEXT      TIME      TOUCH     UNHIDE    UNPROTECT");
	puts("UNSYSTEM  UNTOUCH   VBOX      VCOLOR    VFRAME    VLINE     VERSION");
	puts("VIEW      *BREAK    +         -         *         /");
}

hex_command()
{
	long num_1;

	found=yes;
	if (word_count>=2) {
		num_1=atol(word[1]);
		printf("\tHex number: %lx\n",num_1);
	}
	else puts("\tNeeds decimal number");
}

hide_file()
{
	int der;

	found=yes;
	if (word_count<2) {
		if (!find_file(all_extensions,word[1],"HIDE select file")) return;
	}
	der=Fattrib(word[1],1,HIDDEN);
	if (der<0) disk_error(der);
}

if_command()
{
	int fnd,sub_if=no,start_word=3,success=no;
	char work_string[SLENGTH];

	found=yes;
	if (word_count<3) {
		puts("\tCheck the documentation for proper usage");
		return;
	}
	if ( (sub_if==no) AND (strcmp(word[2],"=")==0)) {
		start_word=4;
		if (strcmp(word[1],word[3])==0) success=yes;
		sub_if=yes;
	}
	if ( (sub_if==no) AND (strcmp(word[2],"!=")==0)) {
		start_word=4;
		if (strcmp(word[1],word[3])!=0) success=yes;
		sub_if=yes;
	}

	if ( (sub_if==no) AND (strcmp(word[1],"EXISTS")==0)) {
		fnd=Fsfirst(word[2],ALL_FILES);
		if (fnd>=0) success=yes;
		sub_if=yes;
	}
	if ( (sub_if==no) AND (strcmp(word[1],"NOTEXISTS")==0)) {
		fnd=Fsfirst(word[2],ALL_FILES);
		if (fnd<0) success=yes;
		sub_if=yes;
	}
	if ( (sub_if==no) AND (strcmp(word[1],"FOLDER")==0)) {
		Fsetdta(&new_dta);
		fnd=Fsfirst(word[2],FOLDER);
		if ((fnd>=0) AND (new_dta.attribute & FOLDER)) success=yes;
		Fsetdta(old_dta);
		sub_if=yes;
	}
	if ( (sub_if==no) AND (strcmp(word[1],"NOTFOLDER")==0)) {
		Fsetdta(&new_dta);
		fnd=Fsfirst(word[2],FOLDER);
		if ( (fnd<0) OR (!(new_dta.attribute & FOLDER)) ) success=yes;
		Fsetdta(old_dta);
		sub_if=yes;
	}
	if (sub_if==no) {
		puts("\tIF command was not used correctly");
		return;
	}
	if (success==yes) {
		strcpy(work_string,&zline[word_loc[start_word]]);
		erase_stuff();
		strcpy(zline,work_string);
		strcpy(command,zline);
		str_t_upper(command);
		word_count=parse(zline,NUM_WORDS,word_loc,delim_loc);
		fill_words();
		if (word_count>0) {
			found=no;
			find_command();
			if (found==no) check_drive();
			if (found==no) check_files();
			if (found==no) printf("\t*Error in IF: No no such command as %s\n",word[0]);
		}
		erase_stuff();
		found=yes;
	}
}

show_iorec()
{
	int choice,device=(-1);
	iorec *xiorec;

	found=yes;
	if (word_count<2) return;
	if (strcmp(word[1],"RS232")==0) device=0;
	if (strcmp(word[1],"KEYBOARD")==0) device=1;
	if (strcmp(word[1],"MIDI")==0) device=2;
	if (device<0) {
		puts("not a legal device");
		return;
	}
	xiorec=(iorec *)Iorec(device);
	printf("\tbuffer address = (hex) %lx\n",xiorec->ibuf);
	printf("\tbuffer size = %d\n",xiorec->ibufsiz);
	printf("\thead index = %d\n",xiorec->ibufhd);
	printf("\ttail index = %d\n",xiorec->ibuftl);
	printf("\tlow mark = %d\n",xiorec->ibuflow);
	printf("\thigh mark = %d\n",xiorec->ibufhigh);
}

keycode()
{
	int key=0;
	long bigkey;

	found=yes;
	puts("\tPress ESCAPE to quit and other key to get code");
	while(key!=27) {
		bigkey=Crawcin();
		key=bigkey;
		Cconout(32);
		Bconout(5,key);
		printf("\t(long)hex:%9lx (int)hex:%5x\n",bigkey,key);
	}
}

macro_command()
{
	int x,mac_num,mac_count=0;

	found=yes;
	if (word_count<2) {
		for (x=0;x<10;x++) {
			if (macro_name[x][0]) {
				printf("\t%d %s:\n%s\n",x,macro_name[x],macro[x]);
				mac_count++;
			}
		}
		if (mac_count==0) puts("\tNo macros are defined");
		else printf("\tused macros: %d. remaining: %d\n",mac_count,10-mac_count);
	}
	if ((word_count==2) OR (word_count>=4)) {
		mac_num=atoi(word[1]);
		if ((mac_num<0) OR (mac_num>9)) {
			puts("\tMacro number out of range (0-9)");
			return;
		}
		if (word_count==2) {
			if (strcmp(word[1],"CLEAR")==0) {
				for (x=0;x<10;x++) {
					bzero(macro[x],SLENGTH);
					bzero(macro_name[x],SLENGTH);
				}
				puts("\tAll Macros were erased");
				return;
			}
			bzero(macro[mac_num],SLENGTH);
			bzero(macro_name[mac_num],SLENGTH);
		}
		if (word_count>=4) {
			bzero(macro_name[mac_num],SLENGTH);
			bzero(macro[mac_num],SLENGTH);
			strcpy(macro_name[mac_num],word[2]);
			strcpy(macro[mac_num],&zline[word_loc[3]]);
		}
	}
}


macro_load()
{
	int fh,x;
	long br;
	char mac_ext[SLENGTH];

	found=yes;
	strcpy(mac_ext,"*.MAC");
	if (word_count<2) {
		if (!find_file(mac_ext,word[1],"MACROLOAD Select a macro file")) return;
	}
	fh=Fopen(word[1],1);
	if (fh>=0) {
		for(x=0;x<NUM_MACROS;x++) {
			br=Fread(fh,128L,macro_name[x]);
			if (br<1) {
				puts("\tError reading file");
				break;
			}
			br=Fread(fh,128L,macro[x]);
			if (br<1) {
				puts("\tError reading file");
				break;
			}
		}
		Fclose(fh);
	}
	else disk_error(fh);
}

macro_save()
{
	int fh,x;
	long bw;
	char mac_ext[SLENGTH];

	found=yes;
	strcpy(mac_ext,"*.MAC");
	if (word_count<2) {
		if (!find_file(mac_ext,word[1],"MACROSAVE Select a macro file")) return;
	}
	fh=Fcreate(word[1],0);
	if (fh>=0) {
		for(x=0;x<NUM_MACROS;x++) {
			bw=Fwrite(fh,128L,macro_name[x]);
			if (bw<1) {
				puts("\tError writing file");
				break;
			}
			bw=Fwrite(fh,128L,macro[x]);
			if (bw<1) {
				puts("\tError writing file");
				break;
			}
		}
		Fclose(fh);
	}
	else disk_error(fh);
}


math_command()
{
	double num_1,num_2;

	found=yes;
	num_1=atof(word[1]);
	if (strcmp(word[0],"=")==0) {
		if (word_count>=2) math_var=num_1;
	}
	if (strcmp(word[0],"+")==0) {
		if (word_count>=2) math_var+=num_1;
	}
	if (strcmp(word[0],"-")==0) {
		if (word_count>=2) math_var-=num_1;
	}
	if (strcmp(word[0],"*")==0) {
		if (word_count>=2) math_var*=num_1;
	}
	if (strcmp(word[0],"/")==0) {
		if (word_count>=2) {
			if (num_1==0) {
				puts("\tDivide by zero not allowed");
				return;
			}
			math_var/=num_1;
		}
	}
	if (strcmp(word[0],"SQR")==0) {
		if (word_count==1) math_var=sqr(math_var);
		if (word_count>=2) math_var=sqr(num_1);
	}
	if (strcmp(word[0],"SQRT")==0) {
		if (word_count==1) {
			if (math_var<0) {
				puts("\tCannot get square root of negative numbers");
				return;
			}
			math_var=sqrt(math_var);
		}
		if (word_count>=2) {
			if (num_1<0) {
				puts("\tCannot get square root of negative numbers");
				return;
			}
			math_var=sqrt(num_1);
		}
	}
	if (strcmp(word[0],"DINT")==0) {
		math_var=dint(math_var);
	}
	printf("\tResult is %f\n",math_var);
}

set_path()
{
	int der;

	found=yes;
	if (word_count<2) {
		path[0]=Dgetdrv()+65;
		path[1]=':';
		Dgetpath(&path[2],0);
		printf("\tCurrent path: %s\n",path);
		return;
	}
	if (strcmp(word[1],"SET")==0) {
		if (word_count>=3) {
			der=Dsetpath(word[2]);
			if (der<0) disk_error(der);
		}
		else {
			if (!find_file(all_extensions,word[2],"PATH Select a path")) return;
			der=Dsetpath(word[2]);
			if (der<0) disk_error(der);
			printf("%s\n",word[2]);
		}
	}
}

pause_command()
{
	found=yes;
	puts("\t>>>PRESS ANY KEY TO CONTINUE<<<");
	dummy=Crawcin();
}

pos_command()
{
	int xpos,ypos;

	found=yes;
	if (word_count<3) puts("\tNeeds the x,y coordinates for cursor to be placed");
	else {
		xpos=atoi(word[1]);
		ypos=atoi(word[2]);
		if (xpos<0) xpos=0;
		if (ypos<0) ypos=0;
		if (xpos>79) xpos=79;
		if (ypos>24) ypos=24;
		crsrsetpos(xpos,ypos);
	}
}

print_file()
{
	int fh,kstat,pstat,x;
	long br;
	char buffer[4096];


	found=yes;
	if (word_count<2) {
		if (!find_file(all_extensions,word[1],"PRINT select a file")) return;
	}
	fh=Fopen(word[1],0);
	if (fh>=0) {
		br=1;
		while(br>0) {
			br=Fread(fh,4000L,buffer);
			for (x=0;x<br;x++) {
				pstat=0;
				while (pstat==0) {
					kstat=Cconis();
					if (kstat!=0) break;
					pstat=Cprnos();
				}
				if (kstat!=0) break;
				Cprnout(buffer[x]);
			}
		}
		Fclose(fh);
	}
	else disk_error(fh);
}

protect_file()
{
	int der;

	found=yes;
	if (word_count<2) {
		if (!find_file(all_extensions,word[1],"PROTECT select file")) return;
	}
	der=Fattrib(word[1],1,READONLY);
	if (der<0) disk_error(der);
}

mkdir()
{
	int der;

	found=yes;
	if (word_count<2) {
		if (!find_file(all_extensions,word[1],"MKDIR select a new folder name")) return;
	}
	der=Dcreate(word[1]);
	if (der<0) disk_error(der);
}

rename_file()
{
	int der;

	found=yes;
	if (word_count<3) {
		if (word_count==1) {
			if (!find_file(all_extensions,word[1],"RENAME original filename")) return;
			if (!find_file(all_extensions,word[2],"RENAME new filename")) return;
		}
		if (word_count==2) {
			if (!find_file(all_extensions,word[2],"RENAME new filename")) return;
		}
	}
	der=Frename(0,word[1],word[2]);
	if (der<0) disk_error(der);
}

rmdir()
{
	int der;

	found=yes;
	if (word_count<2) {
		if (!find_file(all_extensions,word[1],"RMDIR select folder name to delete")) return;
	}
	der=Ddelete(word[1]);
	if (der<0) disk_error(der);
}

screen()
{
	long phys,logic;

	found=yes;
	phys=Physbase();
	logic=Logbase();
	printf("\tPhysical screen address: (hex) %ld\n",phys);
	printf("\tLocical screen address: (hex) %ld\n",logic);
}

set_variable()
{
	int x;

	found=yes;
	if (word_count<3) {
		for (x=0;x<10;x++) printf("%d : %s\n",x,variable[x]);
		return;
	}
	if ((word[1][0]>='0') AND (word[1][0]<='9')) strcpy(variable[word[1][0]-'0'],word[2]);
}

setcolor_command()
{
	int col_num;
	int value[3];
	int combine;
	int x;

	found=yes;
	if (word_count<5) {
		for (x=0;x<16;x++) {
			combine=Setcolor(x,-1);
			printf("\tColor register: %d  hex value: %x\n",x,combine);
		}
	}
	else {
		col_num=atoi(word[1]);
		if ((col_num<0) OR (col_num>15)) {
			puts("\tValue out of range");
			return;
		}
		for (x=0;x<3;x++) {
			value[x]=atoi(word[2+x]);
			if ((value[x]<0) OR (value[x]>7)) {
				puts("\tValue out of range");
				return;
			}
		}
		combine=(value[0]<<8);
		combine+=(value[1]<<4);
		combine+=value[2];
		Setcolor(col_num,combine);
	}
}


system_file()
{
	int der;

	found=yes;
	if (word_count<2) {
		if (!find_file(all_extensions,word[1],"SYSTEM select file")) return;
	}
	der=Fattrib(word[1],1,SYSTEM);
	if (der<0) disk_error(der);
}

write_text()
{
	found=yes;
	printf("%s\n",&zline[word_loc[1]]);
}

time()
{
	int hours,minutes,value;
	timeinfo xtime;

	found=yes;
	xtime.realtime=Tgettime();
	if (word_count>=3) {
		hours=atoi(word[1]);
		minutes=atoi(word[2]);
		xtime.part.hours=hours;
		xtime.part.minutes=minutes;
		xtime.part.seconds=0;
		Tsettime(xtime.realtime);
	}
	else printf("\tSystem time: %2d:%02d\n",xtime.part.hours,xtime.part.minutes);
}


touch_file()
{
	int	fh,der;
	union STAMP {
		struct  {
			int time;
			int date;
		} section;
		long realstamp;
	}	stamp;

	found=yes;
	if (word_count<2) {
		if (!find_file(all_extensions,word[2],"TOUCH select file")) return;
	}
	fh=Fopen(word[1],2);
	if (fh>=0) {
		stamp.section.time=Tgettime();
		stamp.section.date=Tgetdate();
		der=Fdatime(&stamp.realstamp,fh,1);
		if (der<0) disk_error(der);
		Fclose(fh);
	}
	else disk_error(fh);
}

undo_file()
{
	int der;
	char title_string[SLENGTH];

	found=yes;
	if (strcmp(word[0],"HIDE")==0) strcpy(title_string,"HIDE");
	if (strcmp(word[0],"PROTECT")==0) strcpy(title_string,"PROTECT");
	if (strcmp(word[0],"SYSTEM")==0) strcpy(title_string,"SYSTEM");
	strcat(title_string," select file");
	if (word_count<2) {
		if (!find_file(all_extensions,word[1],title_string)) return;
	}
	der=Fattrib(word[1],1,0);
	if (der<0) disk_error(der);
}

untouch_file()
{
	int	fh,der;
	union STAMP {
		struct  {
			int time;
			int date;
		} section;
		long realstamp;
	}	stamp;

	found=yes;
	if (word_count<2) {
		if (!find_file(all_extensions,word[2],"UNTOUCH select file")) return;
	}
	fh=Fopen(word[1],2);
	if (fh>=0) {
		der=Fdatime(&stamp.realstamp,fh,0);
		if (der<0) disk_error(der);
		Fclose(fh);
		Tsettime(stamp.section.time);
		Tsetdate(stamp.section.date);
	}
	else disk_error(fh);
}
vdi_box()
{
	int pxy[4],x;

	found=yes;
	if (word_count<5) puts("\tNeeds the coordinates (x1,y1,x2,y2) for the box to be drawn");
	else {
		for (x=0;x<4;x++) {
			pxy[x]=atoi(word[1+x]);
			if (pxy[x]<0) pxy[0]=0;
		}
		if (pxy[2]>work_out[0]) pxy[2]=work_out[0];
		if (pxy[3]>work_out[1]) pxy[3]=work_out[1];
		v_bar(handle,pxy);
	}
}

vdi_color()
{
	int col_num;

	found=yes;
	if (word_count<2) puts("\tNeed the number of a color to select");
	else {
		col_num=atoi(word[1]);
		if (col_num<0) col_num=0;
		if (col_num>16) col_num=16;
		vsf_color(handle,col_num);
		vsm_color(handle,col_num);
		vst_color(handle,col_num);
		vsf_color(handle,col_num);
	}
}

vdi_frame()
{
	int pxy[10],x,x1,x2,y1,y2;

	found=yes;
	if (word_count<5) puts("\tNeeds the coordinates (x1,y1,x2,y2) for the frame to be drawn");
	else {
		x1=atoi(word[1]);
		y1=atoi(word[2]);
		x2=atoi(word[3]);
		y2=atoi(word[4]);
		for (x=0;x<10;x++) if (pxy[x]<0) pxy[0]=0;
		if (x1>work_out[0]) x1=work_out[0];
		if (x2>work_out[0]) x2=work_out[0];
		if (y1>work_out[1]) y1=work_out[1];
		if (y2>work_out[1]) y2=work_out[1];
		pxy[0]=pxy[6]=pxy[8]=x1;
		pxy[1]=pxy[3]=pxy[9]=y1;
		pxy[2]=pxy[4]=x2;
		pxy[5]=pxy[7]=y2;
		v_pline(handle,5,pxy);
	}
}

vdi_line()
{
	int pxy[4],x;

	found=yes;
	if (word_count<5) puts("\tNeeds the coordinates (x1,y1,x2,y2) for the line to be drawn");
	else {
		for (x=0;x<4;x++) {
			pxy[x]=atoi(word[1+x]);
			if (pxy[x]<0) pxy[0]=0;
		}
		if (pxy[2]>work_out[0]) pxy[2]=work_out[0];
		if (pxy[3]>work_out[1]) pxy[3]=work_out[1];
		v_pline(handle,2,pxy);
	}
}


show_version()
{
	union {
		struct {
			char major;
			char minor;
		} byte;
		int realversion;
	} version;

	found=yes;
	version.realversion=Sversion();
	printf("\tGEM version %d.%d\n",(int)version.byte.major,(int)version.byte.minor);
}

view()
{
	int fh,ox,oy,key,val;
	long br=1,x;
	char buffer[4096];

	found=yes;
	if (word_count<2) if (!find_file(all_extensions,word[1],"VIEW filename")) return;
	fh=Fopen(word[1],0);
	if (fh>=0) {
		crsrcls();
		while(br>0) {
			br=Fread(fh,4000L,buffer);
			if (br==0) break;
			for (x=0;x<br;x++) {
				val=buffer[x];
				Cconout(val);
				crsrgetpos(&ox,&oy);
				if (oy>20) {
					Cconout(13);
					v_rvon(handle);
					puts("\tPress SPACE BAR to continue or ESCAPE to exit");
					v_rvoff(handle);
					key=Crawcin();
					if (key==27) {
						br=0;
						break;
					}
					crsrcls();
				}
			}
		}
		Fclose(fh);
	}
	else disk_error(fh);
}

volume()
{
	int fnd;
	char search[SLENGTH];

	found=yes;
	drive=Dgetdrv();
	strcpy(search,"\\*.*");
	Fsetdta(&new_dta);
	fnd=Fsfirst(search,VOLUME);
	if (fnd>=0) printf("\tVolume on drive %c is %s\n",drive+'A',new_dta.fname);
	else printf("\tDrive %c has no volume\n",drive+'A');
	Fsetdta(old_dta);
}


/*	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-*/
/*	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-*/
/*	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-*/
/*	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-*/
/*	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-*/
/*	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-*/
/*	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-*/

erase_stuff()
{
	int x,y;

	for (x=0;x<NUM_WORDS;x++) {
		bzero(word[x],SLENGTH);
		word_loc[x]=0;
		delim_loc[x]=0;
	}
	bzero(zline,SLENGTH);
	bzero(command,SLENGTH);
	word_count=0;
}

stuff_variables()
{
	int zc=0,lc=0;
	int done=no;
	char number[SLENGTH];
	char line[1025];

	while (done==no) {
		line[lc]=zline[zc];
		if (zline[zc]==0) break;
		if ((zline[zc]=='%') AND (zline[zc+1]>='0') AND (zline[zc+1]<='9')) {
			line[lc]=0;
			strcat(line,variable[zline[zc+1]-'0']);
			lc=strlen(line);
			if (lc>128) break;
			zc+=2;
		}
		else {
			lc++;
			zc++;
		}
	}
	line[128]=0;
	strcpy(zline,line);
}

fill_words()
{
	int x,length;

	for (x=0;x<word_count;x++) {
		length=(delim_loc[x]-word_loc[x]);
		strncpy(word[x],&command[word_loc[x]],length);
	}
}

get_dir_path()
{
	int length,value;

	if (word_count<2) {
		path[0]=Dgetdrv()+65;
		path[1]=':';
		Dgetpath(&path[2],0);
		strcat(path,"\\*.*");
	}
	else {
		strcpy(path,word[1]);
		length=strlen(path);
		value=path[length-1];
		if ((length==1) AND (value>='A') AND (value<='P')) strcat(path,":\\*.*");
		if ((length==1) AND (value=='\\')) strcat(path,"*.*");
		if ((length==2) AND (value>=':')) strcat(path,"\\*.*");
		if ((length>=3) AND (value=='\\')) strcat(path,"*.*");
	}



}

check_macros()
{
	int x;

	for (x=0;x<10;x++) {
		if (strcmp(macro_name[x],command)==0) {
			strcpy(zline,macro[x]);
			strcpy(command,zline);
			str_t_upper(command);
			break;
		}
	}
}

check_drive()
{
	int length;

	length=strlen(word[0]);
	if (length==2) {
		if ((word[0][1]==':') AND (word[0][0]>='A') AND (word[0][0]<='P')) {
			Dsetdrv(word[0][0]-65);
			found=yes;
		}
	}
}

check_files()
{
	int fnd,pxy[4],x;
	char commandline[256];
	char prg_ext[128],ttp_ext[128],tos_ext[128],bat_ext[128];

	strcpy(prg_ext,".PRG");
	strcpy(ttp_ext,".TTP");
	strcpy(tos_ext,".TOS");
	strcpy(bat_ext,".BAT");
	if (word_count>1) strcpy(&commandline[1],&zline[word_loc[1]]);
	commandline[128]=0;
	commandline[0]=strlen(commandline);
	fnd=Fsfirst(word[0],ALL_FILES);
	if (fnd>=0) {
		if (has_ext(word[0],prg_ext)) {
			found=yes;
			Cursconf(0,0);
			crsrcls();
			vsf_color(handle,3);
			pxy[0]=pxy[1]=0;
			pxy[2]=work_out[0];
			pxy[3]=work_out[1];
			v_bar(handle,pxy);
			v_show_c(handle,0);
			graf_mouse(257,0L);
			Pexec(0,word[0],commandline,0L);
			v_hide_c(handle);
			graf_mouse(256,0L);
			crsrcls();
			Cursconf(1,0);
		}
		if ((has_ext(word[0],tos_ext)) OR (has_ext(word[0],ttp_ext))) {
			found=yes;
			Pexec(0,word[0],commandline,0L);
			v_hide_c(handle);
			graf_mouse(256,0L);
			Cursconf(1,0);
			crsrcolor(3,0);
		}
		if ((has_ext(word[0],bat_ext)) ) {
			found=yes;
			batch_stat++;
			if (batch_stat>NUM_BATCH) {
				batch_stat=(NUM_BATCH-1);
			}
			else {
				for(x=0;x<10;x++) bzero(variable[x],SLENGTH);
				if (word_count>1) {
					for(x=0;x<10;x++) 	strcpy(variable[x],word[x+1]);
				}
				do_batch(word[0]);
				batch_stat--;
				if (batch_stat<0) batch_stat=0;
			}
		}
	}
}

do_batch(filename)
char *filename;
{
	int x,xlen,xpos,buflength,done=no,z;
	char tline[SLENGTH],fname[128],linef[10];
	char *next_line;
	char *buffer;
	FILE *fp;

	buffer=(char *)Malloc(BATCH_SIZE);
	if (!buffer) {
		puts("\tCould not allocate %ld bytes of memory to load batch file");
		return;
	}

	linef[0]=10;
	linef[1]=0;
	for (z=0;z<BATCH_SIZE;z++) buffer[z]=0;
	strcpy(fname,filename);
	fp=fopen(fname,"r");
	if (fp!=0) {
		while (fp!=0) {
			bzero(tline,SLENGTH);
			fgets(tline,77,fp);
			xlen=strlen(tline);
			if (xlen<1) break;
			for (x=0;x<xlen;x++) {
				if ((tline[x]==13) OR (tline[x]==10)) tline[x]=0;
			}
			if (((strlen(buffer))+(strlen(tline)))>=BATCH_SIZE) {
				puts("\t*ERROR* the batch file was too large. Not all of it was loaded");
				break;
			}
			strcat(buffer,tline);
			strcat(buffer,linef);
		}
		fclose(fp);
	}
	else {
		printf("\tThere was an error trying to open %s\n",fname);
		return;
	}
	done=no;
	xpos=0;
	while(done==no) {
		found=no;
		bzero(tline,SLENGTH);
		next_line=index(buffer,10);
		if (!next_line) break;
		next_line+=1;
		for (x=0;x<SLENGTH;x++) {
			if (buffer[x]!=10) tline[x]=buffer[x];
			else break;
		}
		strcpy(buffer,next_line);
		erase_stuff();
		strcpy(zline,tline);
		stuff_variables();
		strcpy(command,zline);
		str_t_upper(command);
		check_macros();
		word_count=parse(zline,NUM_WORDS,word_loc,delim_loc);
		fill_words();
		if (word_count>0) {
			found=no;
			find_command();
			if (found==no) check_drive();
			if (found==no) check_files();
			if (found==no) {
				if (strcmp(word[0],"BREAK")==0) {
					found=yes;
					done=yes;
				}
			}
			if (found==no) printf("\tThere was no such command as %s\n",word[0]);
		}
	}
	found=yes;
}

application(func)
int		func;
{
	int		x;

	if (func!=0) {
		appl_init();
		phys_handle=graf_handle(&dummy,&dummy,&dummy,&dummy);
		handle=phys_handle;
		v_opnvwk(work_in,&handle,work_out);
		v_hide_c(handle);
		graf_mouse(0,0L);
		graf_mouse(256,0L);
		v_clrwk(handle);
		rez=Getrez();
		v_rvoff(handle);
		crsrcolor(3,0);
		crsrcls();
		Cursconf(1,0);
		old_dta=Fgetdta();
	}
	else {/*un-set up*/
		Cursconf(0,0);
		crsrcls();
		graf_mouse(257,0L);
		v_show_c(handle,0);
		v_clsvwk(handle);
		appl_exit();
		exit (0);
	}
}

find_command()
{
	if (strcmp(word[0],"ASCII")==0) ascii_chart();
	if (strcmp(word[0],"BINARY")==0) binary_command();
	if (strcmp(word[0],"BYE")==0) bye();
	if (strcmp(word[0],"CLS")==0) cls_command();
	if (strcmp(word[0],"COPY")==0) copy();
	if (strcmp(word[0],"CP")==0) copy();
	if (strcmp(word[0],"CPRNOUT")==0) cprnout_command();
	if (strcmp(word[0],"DATE")==0) date();
	if (strcmp(word[0],"DEC")==0) decimal_command();
	if (strcmp(word[0],"DEL")==0) delete();
	if (strcmp(word[0],"DELETE")==0) delete();
	if (strcmp(word[0],"DD")==0) dd();
	if (strcmp(word[0],"D")==0) dir();
	if (strcmp(word[0],"DIR")==0) dir();
	if (strcmp(word[0],"DISK")==0) disk();
	if (strcmp(word[0],"EXAMINE")==0) examine_file();
	if (strcmp(word[0],"EXIT")==0) bye();
	if (strcmp(word[0],"FILE")==0) create_file();
	if (strcmp(word[0],"FORMAT")==0) format_command();
	if (strcmp(word[0],"HELP")==0) help();
	if (strcmp(word[0],"HEX")==0) hex_command();
	if (strcmp(word[0],"HIDE")==0) hide_file();
	if (strcmp(word[0],"?")==0) help();
	if (strcmp(word[0],"IF")==0) if_command();
	if (strcmp(word[0],"IOREC")==0) show_iorec();
	if (strcmp(word[0],"KEYCODE")==0) keycode();
	if (strcmp(word[0],"MACRO")==0) macro_command();
	if (strcmp(word[0],"MACROLOAD")==0) macro_load();
	if (strcmp(word[0],"MACROSAVE")==0) macro_save();
	if (strcmp(word[0],"PATH")==0) set_path();
	if (strcmp(word[0],"PAUSE")==0) pause_command();
	if (strcmp(word[0],"POS")==0) pos_command();
	if (strcmp(word[0],"PRINT")==0) print_file();
	if (strcmp(word[0],"PROTECT")==0) protect_file();
	if (strcmp(word[0],"MKDIR")==0) mkdir();
	if (strcmp(word[0],"QUIT")==0) bye();
	if (strcmp(word[0],"REN")==0) rename_file();
	if (strcmp(word[0],"RENAME")==0) rename_file();
	if (strcmp(word[0],"RMDIR")==0) rmdir();
	if (strcmp(word[0],"SCREEN")==0) screen();
	if (strcmp(word[0],"SET")==0) set_variable();
	if (strcmp(word[0],"SETCOLOR")==0) setcolor_command();
	if (strcmp(word[0],"SYSTEM")==0) system_file();
	if (strcmp(word[0],"TEXT")==0) write_text();
	if (strcmp(word[0],"TIME")==0) time();
	if (strcmp(word[0],"TOUCH")==0) touch_file();
	if (strcmp(word[0],"UNHIDE")==0) undo_file();
	if (strcmp(word[0],"UNPROTECT")==0) undo_file();
	if (strcmp(word[0],"UNSYSTEM")==0) undo_file();
	if (strcmp(word[0],"UNTOUCH")==0) untouch_file();
	if (strcmp(word[0],"VBOX")==0) vdi_box();
	if (strcmp(word[0],"VCOLOR")==0) vdi_color();
	if (strcmp(word[0],"VFRAME")==0) vdi_frame();
	if (strcmp(word[0],"VLINE")==0) vdi_line();
	if (strcmp(word[0],"VERSION")==0) show_version();
	if (strcmp(word[0],"VIEW")==0) view();
	if (strcmp(word[0],"+")==0) math_command();
	if (strcmp(word[0],"-")==0) math_command();
	if (strcmp(word[0],"*")==0) math_command();
	if (strcmp(word[0],"/")==0) math_command();
	if (strcmp(word[0],"=")==0) math_command();
	if (strcmp(word[0],"SQR")==0) math_command();
	if (strcmp(word[0],"SQRT")==0) math_command();
}
