#include <osbind.h>
#include <stdio.h>
#include <strings.h>

#define AND &&
#define OR ||
#define SLENGTH 128

extern int handle;

crsrcls()
{
	/*clear screen and place cursor in home position*/
	Cconout(27);
	Cconout('E');
}

crsrinsertline()
{
	/*insert a blank line at cursor position (shift all lines*/
	/*blow it down*/
	Cconout(27);
	Cconout('L');
}

crsrdeleteline()
{
	/*delete line cursor is on and move all lines below up*/
	Cconout(27);
	Cconout('M');
}

crsrsetpos(x,y)
int x,y;
{
	/*set cursor x,y coordinate (upper-left hand corner is 0,0)*/
	Cconout(27);
	Cconout('Y');
	Cconout(y+32);
	Cconout(x+32);
}

crsrgetpos(x,y)
int *x,*y;
{
	/*get the cursor x,y coordinates*/
	vq_curaddress(handle,y,x);
	*y-=1;
	*x-=1;
}

crsrcolor(f,b)
int f,b;
{
	/*Set cursor foreground and background color*/
	Cconout(27);
	Cconout('b');
	Cconout(f+'0');

	Cconout(27);
	Cconout('c');
	Cconout(b+'0');
}

crsrclrtocrsr()
{
	/*clear from top of screen to cursor position*/
	Cconout('27');
	Cconout('c');
}

str_t_upper(string)
char *string;
{
	/*convert string to uppercase*/
	int x,length;
	length=strlen(string);
	for (x=0;x<length;x++) {
		if ((string[x]>='a') && (string[x]<='z')) string[x]-=32;
	}
}

str_t_lower(string)
char *string;
{
	/*convert string to lowercase*/
	int x,length;
	length=strlen(string);
	for (x=0;x<length;x++) {
		if ((string[x]>='A') && (string[x]<='Z')) string[x]+=32;
	}
}


parse(string,elements,part_pos,delim_pos)
char *string;
int elements;
int	part_pos[];
int delim_pos[];
{
	/*parse a string*/
	/*honest to god I wrote this so long ago I can't remember*/
	/*how it all works*/

	int		x=0,z=0,i=0,part_count=0,length;

	length=strlen(string)+1;
	while (part_count<elements) {
		z=string[x];
		while( (z<33) AND (x<length) ) {
			x++;
			z=string[x];
		}
		part_pos[part_count]=x;
		while( (z>32) AND (x<length) ) {
			x++;
			z=string[x];
		}
		delim_pos[part_count]=x;
		if (x>=length) break;
		part_count++;
	}
	return (part_count);
}

find_file(extension,filename,title)
char *extension,*filename,*title;
{
	int choice,ox,oy,xpos,pxy[4];
	long screen_buffer,rez;
	char xname[SLENGTH],path[SLENGTH],*position;

	/* complete fsel_input handling routine*/

	rez=Getrez();
	screen_buffer=Malloc(32000L);
	if (screen_buffer<1) {
		form_alert(1,"[3][Could not Malloc|32K for screen][OK]");
		return;
	}

	Cursconf(0,0);
	/*save screen*/
	bcopy(Physbase(),screen_buffer,32000);

	/*draw the title so user can see for what he's selecting*/
	crsrgetpos(&ox,&oy);
	xpos=(80-strlen(title))/2;
	pxy[0]=(xpos*8)-10;
	pxy[1]=3;
	pxy[2]=(xpos*8)+((strlen(title))*8)+10;
	pxy[3]=22;
	if (rez==2) pxy[3]*=2;
	vsf_color(handle,1);
	v_bar(handle,pxy);
	pxy[0]+=2;
	pxy[1]+=2;
	pxy[2]-=2;
	pxy[3]-=2;
	vsf_color(handle,0);
	v_bar(handle,pxy);
	/*print the actual title the box*/
	crsrsetpos(xpos,1);
	printf("%s\n",title);
	crsrsetpos(ox,oy);

	/*remember to turn on the mouse for fsel_input*/
	graf_mouse(257,0L);
	v_show_c(handle,0);

	/*get the current path from the current drive*/
	path[0]=Dgetdrv()+65;
	path[1]=':';
	Dgetpath(&path[2],0);
	strcat(path,extension);

	/*call fsel_input*/
	fsel_input(path,filename,&choice);
	if (choice==1) {/*if the OK button was pressed*/
		/*make filename[] a proper filename with path included*/
		strcpy(xname,path);
		position=rindex(xname,'\\');
		strcpy(position+1,filename);
		strcpy(filename,xname);
	}
	/*turn off the rodent*/
	v_hide_c(handle);
	graf_mouse(256,0L);

	/*redraw the screen*/
	bcopy(screen_buffer,Physbase(),32000);
	Cursconf(1,0);
	Mfree(screen_buffer);
	return (choice);
}

ms_list(list,items,length,tx,ty,fcolor,bcolor,selected)
char	*list[];
int	items,length,tx,ty,fcolor,bcolor,*selected;
{
	/* mouse selection menu routine */

	int	y,mx,my,mb,oldx=-1,oldy=-1,calcx=0,calcy=0,done=0,ysize=10,
		dum,xlength,ylength,box_x2,box_y2,pxy[4];

	long screen_buffer;

	screen_buffer=Malloc(32000L);
	if (screen_buffer<1) {
		form_alert(1,"[3][Could not Malloc|32K for screen][OK]");
		*selected=-2;
		return;
	}
	bcopy(Physbase(),screen_buffer,32000);
	if (Getrez()==2) ysize=20;
	xlength=(length*8)+16;
	ylength=(items*ysize);
	box_x2=tx+xlength;
	box_y2=ty+ylength;
	vsf_color(handle,bcolor);
	pxy[0]=tx;
	pxy[1]=ty;
	pxy[2]=box_x2;
	pxy[3]=box_y2+1;
	v_bar(handle,pxy);
	vswr_mode(handle,2);
	vst_color(handle,fcolor);
	for(y=0;y<items;y++) v_gtext(handle,tx+8,ty+(y*ysize)+ysize-2,list[y]);
	vswr_mode(handle,1);
	graf_mouse(257,0L);
	v_show_c(handle,0);
	while(done==0){
		vq_mouse(handle,&mb,&mx,&my);
		if (my<ty) my=-1;
		calcy=((my-ty)/ysize);
		if ((mx>tx) AND (mx<box_x2)) calcx=1;
		else calcx=0;
		if (mb>1) {
			*selected=(-1);
			break;
		}
		if (mb==1) {
			if ((calcy>=0) AND (calcy<items) AND (calcx==1)) {
				*selected=calcy;
				break;
			}
			if ((calcy<0) OR (calcy>=items) OR (calcy!=1)) {
				*selected=(-1);
				break;
			}
		}
		if ((calcy!=oldy) OR (calcx!=oldx)) {
			vswr_mode(handle,3);
			if ((calcy>=0) AND (calcy<items) AND (calcx==1)) {
				graf_mouse(256,0L);
				pxy[0]=tx;
				pxy[1]=ty+(calcy*ysize);
				pxy[2]=tx+xlength;
				pxy[3]=ty+ysize+(calcy*ysize)+1;
				v_bar(handle,pxy);
				graf_mouse(257,0L);
			}
			if ((oldy>=0) AND (oldy<items) AND (oldx==1)) {
				graf_mouse(256,0L);
				pxy[0]=tx;
				pxy[1]=ty+(oldy*ysize);
				pxy[2]=tx+xlength;
				pxy[3]=ty+ysize+(oldy*ysize)+1;
				v_bar(handle,pxy);
				graf_mouse(257,0L);
			}
			vswr_mode(handle,1);
			oldy=calcy;
			oldx=calcx;
		}
	}
	v_hide_c(handle);
	graf_mouse(256,0L);
	bcopy(screen_buffer,Physbase(),32000);
	if (screen_buffer>0) Mfree(screen_buffer);
} 

disk_error(error_code)
int error_code;
{
	/*show DOS error codes (sent to VT52 screen)*/

	if (error_code<=(-32)) printf("GEMDOS");
	else printf("BIOS");
	printf(" error code #%d ",error_code);
	switch (error_code) {
		case (-1):
			printf("General error\n");
			break;
		case (-2):
			printf("Device was not ready, was not attached,or has been busy for too long\n");
			break;
		case (-3):
			printf("Device didn't understand the command\n");
			break;
		case (-4):
			printf("CRC error (soft read error)\n");
			break;
		case (-5):
			printf("Device couldn't handle the command, although it understood\nthe request.  Check command parameters\n");
			break;
		case (-6):
			printf("Drive couldn't perform the seek\n");
			break;
		case (-7):
			printf("Attempt to read un-formatted or foriegn media\nMay be caused by trashed or zero boot block\n");
			break;
		case (-8):
			printf("The requested sector could not be found\n");
			break;
		case (-9):
			printf("The printer is out of paper\n");
			break;
		case (-10):
			printf("A write operation failed\n");
			break;
		case (-11):
			printf("A read operation failed\n");
			break;
		case (-12):
			printf("General mishap (reserved for future errors)\n");
			break;
		case (-13):
			printf("Attempt to write onto write-protected or read-only media\n");
			break;
		case (-32):
			printf("Invalid function number\n");
			break;
		case (-33):
			printf("File not found\n");
			break;
		case (-34):
			printf("Path not found\n");
			break;
		case (-35):
			printf("No file descriptors left (too many files open)\n");
			break;
		case (-36):
			printf("Access denied\n");
			break;
		case (-37):
			printf("Invalid file descriptor\n");
			break;
		case (-39):
			printf("Insufficient memory\n");
			break;
		case (-40):
			printf("Invalid memory block address\n");
			break;
		case (-46):
			printf("Invalid drive specified\n");
			break;
		case (-49):
			printf("No more files\n");
			break;
		case (-64):
			printf("Range error\n");
			break;
		case (-65):
			printf("Internal error\n");
			break;
		case (-66):
			printf("Invalid program load format\n");
			break;
		case (-67):
			printf("Setblock failure due to growth restrictions\n");
			break;
		default:
			printf("disk error information routine did not work properly\n");
	}
}

getline(string,length)
char	*string;
int		length;
{
	int		ox,oy,key,done=0,xpos=0,x,size=0;
	long	bigkey;
	char	line[128];

	if (length<1) return;
	if (length>79) length=79;
	crsrgetpos(&ox,&oy);
	for(x=0;x<SLENGTH;x++) line[x]=0;

	while(done==0) {
		bigkey=Crawcin();
		key=bigkey;

		if (key==13) {/*check for RETURN key*/
			line[length]=0;
			strcpy(string,line);
			return;
		}
		size=strlen(line);
		if ((bigkey==0x4b0000L) AND (xpos>0)) {/*handle LEFT ARROW key*/
			xpos--;
			crsrsetpos(ox+xpos,oy);
		}
		if (key==27) {/*handle ESCAPE key*/
			for (x=0;x<128;x++) line[x]=0;
			crsrsetpos(ox,oy);
			for (x=0;x<=length;x++) Cconout(32);
			crsrsetpos(ox,oy);
 			xpos=0;
			size=0;
		}
		if ((bigkey==0x4d0000L) AND (xpos<size)) {/*handle RIGHT ARROW key*/
			xpos++;
			crsrsetpos(ox+xpos,oy);
		}
		if ( (key==8) OR (key==0x7f) OR ((key>=32) AND (key<127))){/*check for DELETE,BACKSPACE,or any ASCII key*/
			if ( (key==8) AND (xpos>0) ) {/*handle BACKSPACE*/
				for(x=xpos;x<(size+1);x++) line[x-1]=line[x];
				xpos--;
			}
			if (key==0x7f) {/*handle DELETE key*/
				for(x=xpos;x<size;x++) line[x]=line[x+1];
				line[size]=0;
			}
			if ((key>=32) AND (key<127)) {/*regular ASCII characters*/
				for (x=(length-1);x>xpos;x--) line[x]=line[x-1];
				if (xpos==length) xpos=length-1;
				line[xpos]=key;
				xpos++;
				if (xpos>length) xpos=length;
				line[length]=0;
			}
			Cursconf(0,0);
			crsrsetpos(ox,oy);
			Cconws(line);
			size=strlen(line);
			crsrsetpos(ox+size,oy);
			Cconout(32);
			crsrsetpos(ox+xpos,oy);
			Cursconf(1,0);
		}
	}
}


has_ext(filename,extension)
char *filename,*extension;
{
	char *period;

	period=rindex(filename,'.');
	if (period) {
		if (strcmp(period,extension)==0) return(1);
	}
	return (0);
}
