
/****************************************************************************

    XGLOBAL.H

    - contains of all global declarations and defines

    01/23/88 created
    
    07/14/88 21:00

****************************************************************************/

#ifndef XGLOBAL

#define XGLOBAL

#define xxxDEBUG

#ifndef DEBUG

#define Assert(x,y)
#define Debug(x)
#define Alert(x)

#else   /* DEBUG */

#define Assert(x,y)     if (!(x)) _alert(y);
#define Debug(x)        x

#endif  /* DEBUG */

#define void int

#define TRUE   ~0
#define FALSE   0

#define loop for(;;)

#define Blit(f,t)       _blit(f,t)
#define Blitb(f,t,cb)   _blitb(f,t,cb)
#define Blitbz(f,t,cb)  _blitbz(f,t,cb)
#define Blitw(f,t,cw)   _blitw(f,t,cw)
#define Blitwz(f,t,cw)  _blitwz(f,t,cw)
#define Blitl(f,t,cl)   _blitl(f,t,cl)
#define Blitlz(f,t,cl)  _blitlz(f,t,cl)
#define Blitc(ch,t,cb)  _blitc(ch,t,cb)
#define Blitcz(ch,t,cb) _blitcz(ch,t,cb)
#define Blitzb(t,cb)    _blitzb(t,cb)
#define Blitzw(t,cw)    _blitzw(t,cw)
#define Blitzl(t,cl)    _blitzl(t,cl)
#define BlitCls(t)      _blitcls(t)
#define BlitScr(f,t)    _blitscr(f,t)

extern char
    *_blit(), *_blitb(), *_blitbz(), *_blitw(), *_blitwz(), *_blitl(),
    *_blitlz(), *_blitc(), *_blitcz(), *_blitzb(), *_blitzw(),
    *_blitzl(), *_blitcls(), *_blitscr();

typedef struct
    {
    char foo[26];
    long lFileSize;
    char szName[14];
    } DTA;

extern DTA *qdta;

extern int  RunAt();
extern int  CchDisAsm();
extern int  CchShowRegs();
extern void PutReg();
extern int  GetReg();
extern void Push();
extern int  Pop();
extern void Poke();
extern int  Peek();

extern fn_nul();

extern int  fInMon;
extern int  fTrace;

extern int  fIsMono;
extern long
    lScr,       /* 8 bit screen */
    lScrGEM,    /* desktop screen */
    lScratch,   /* 32K buffer */
    lEmul,      /* == arEmul */
    lRStat,     /* == arRSTAT */
    lWStat,     /* == arWSTAT */
    lMemory,    /* start of 6502 memory */
    lFont8,     /* pointer to 8x8 font */
    lFont16;    /* pointer to 8x16 font */

extern int fReboot;

extern int rgwPalette[16];

#endif
