/* ddir.prg

   displays the file names & file sizes in rows of three
   excepts an optional file name qualifier as a parameter
 
   by: James M. Eli
   1 March 1986

 */

#include <osbind.h>                         /* we need these                 */

char    dta[44],                            /* disk transfer address         */
        *name_of_file,                      /* filename.ext                  */
        file_size[10],                      /* converted ascii file size     */
        *filename,                          /* user supplied argument...     */
        *default_name = "*.*",              /* default if above not supplied */
        crlf[] = { 0x0a, 0x0d, 0x00 };      /* CR & LF for the screen        */

ltoa(l)                                     /* convert long to ascii string  */
long l;                                     /* shamelessly hacked from K & R */
{
    register int i, j;
    register char c;
    i = 0;
    do
        {
        file_size[i++] = l % 10 + '0';
    } while ( (l /= 10) > 0 );
    file_size[i] = '\0';
    j = --i;
    for (i=0; i<j; ++i, --j)
        {
        c = file_size[i];
        file_size[i] = file_size[j];
        file_size[j] = c;
    }
}

main(argc, argv)                            /* start with user supplied args */
int argc;                                   /* we are only concerned about   */
char *argv[];                               /* the first argument            */
{
    register int i,cntr = 0;
    int result;
    long size;
    if (argc > 1)                           /* user is suppling his own...   */
        {
        if (argv[1][2] == '\0')             /* check for just a drive letter */
            for (i=2; i<7; i++)             /* and add the default params.   */
                argv[1][i] = default_name[i-2];
        filename = argv[1];
    }
    else
        filename = default_name;            /* its a go with the defaults    */
                                            /* setup our dta and send GEMDOS */
                                            /* the filename and attributes   */
    asm {
        pea    dta(A4)
        move.w #26,-(A7)
        trap   #1
        addq.l #6,A7
        move.w #17,-(A7)
        move.l filename(A4),-(A7)
        move.w #78,-(A7)
        trap   #1
        addq.l #8,A7
        move.l D0,result(A6)
    }                                       
    if (!result)                            /* if no files, don't do this   */   
        {                                   
        while (!Fsnext())                   /* as long as there are files... */
            {
            name_of_file = &dta[30];        /* get the name from the dta     */
            size = *( long *)(&dta[26]);    /* get the size from the dta     */
            ltoa(size);                     /* convert the size to ascii     */
            if ((cntr++ % 3) == 0)          /* CR & LF every third iteration */
                Cconws(crlf);
            Cconws(name_of_file);           /* output the filename.ext       */
            i = 0;
            while (name_of_file[i++] != '\0');
                while ((i++) < 15)          /* what the !!??!!               */
                                            /* output spaces                 */
                    asm {
                        move.w #32,-(A7)
                        move.w #2,-(A7)
                        trap   #1
                        addq.l #4,A7
                    }
            Cconws(file_size);              /* same as above, but w/the size */
            i = 0;
            while (file_size[i++] != '\0');
                while ((i++) < 14)
                    asm {
                        move.w #32,-(A7)
                        move.w #2,-(A7)
                        trap   #1
                        addq.l #4,A7
                    }
        }
    }
    else                                    /* tell me there are no files... */
        Cconws("No files.");
}                
