#include <stdio.h>
#include <osbind.h>
#include <ctype.h>

#define SAMPLES 15.0
#define TPM 12000.0     /* ticks per minute */
#define NAME "ST Drive Speed Test"
#define VNUM "Version 1.5   December 30, 1985"
#define NOTICE "Copyright 1985 by Michael Curry."

main(argc,argv)
int argc;
char *argv[];
{

        int     t_flag=FALSE,
                drive,
                ttl_read;

        long    get_tick();

        double  speed(),rpm,sum,total,average;

        if (argc!=2) {
                tf_init(80);
                curs_on();
                cls();
                title(NAME,VNUM);
                drive = get_drv("Z");
                curs_off();
                cls();
                center(NAME,0);
                center(VNUM,1);
                center(NOTICE,3);
                hilite();
                center("Checking Drive Speed",9);
                lolite();
                center("Press any key to quit.",23);
        } else {
                t_flag=TRUE;
                printf("%s %s\n%s\n",NAME,VNUM,NOTICE);
                printf("\nPress any key to quit.\n");
                drive = get_drv(argv[1]);
                printf("Checking drive %s\n",argv[1]);
        }
        ttl_read = 0;
        sum = 0.0;

        rpm = speed(drive);     /* start up the drive so speed can
                                   stabilize */

loop:

        rpm=speed(drive);       /* get the rpm and send it back */
        if(Cconis()) {
                Cconin();
                goto end;       /* user pressed a key */
        }

        sum+=rpm;
        ttl_read++;
        average =  sum/ttl_read;

        if(t_flag)
                printf("Speed is %4.3f RPM - average is %4.3f RPM.\n",rpm,average );
        else {
                cursor(13,32);
                printf("  SPEED: %4.3f",rpm);
                cursor(15,32);
                printf("AVERAGE: %4.3f",average);
        }
        goto loop;

end:
        curs_on();
        if (!t_flag) cls();
        return;
}

long get_tick()
{
        long    save_ssp,*t_ptr,temp;

        save_ssp = Super(0L);

        t_ptr = 0x04baL;        /* get the 200 hz timer system var */

        temp = *t_ptr;
        Super(save_ssp);

        return(temp);
}

get_drv(d)
char d[];
{
        char buf[50];
        strcat(buf,d);
start:

        switch (toupper(buf[0])) {
                case 'A':
                        return(0);
                        break;
                case 'B':
                        return(1);
                        break;
                default:
                        printf("\nEnter Drive Letter (A or B) ");
                        input(buf,3);
                        goto start;
        }
}

double speed(drive)
int drive;
{
        char buf[1024]; /* twice as big as they say */

        long s_time,time;
        double rpm,total;
        int i,stat;

        s_time = get_tick();
                
        for(i=0;i<SAMPLES;i++) {
                stat= Floprd(buf,0L,drive,1,0,0,1); /* read sect 1 trk 0 */
                if (Cconis()) goto end;
        }

        time = get_tick();      
        total = time-s_time;    /* get total ticks */

        rpm = ( TPM / (total/SAMPLES));

end:
        return(rpm);
}
