* Translation of FORMAT+ from ANALOG #46
*
* Modifies RAM TOS to create a faster disk format

	.text
	pea	msg1		* Title message
	move.w	#9,-(sp)
	trap	#1
	addq.l	#6,sp

chktos:	cmp.w	#$0529,$5018	* Let's see which version of TOS
	bne	chk2		* we're dealing with
	move.l	#2,adjust
	bra	contin
chk2:	cmp.w	#$0620,$5018
	bne	oops		* Oops, wrong TOS!
	move.l	#0,adjust
	bra	contin

oops:	pea	wrong		* Print "ABORT" message and exit
	move.w	#9,-(sp)
	trap	#1
	addq.l	#6,sp
	bra	exit

contin:	clr.l	-(sp)		* Set supervisor mode
	move.w	#$20,-(sp)
	trap	#1
	addq.l	#6,sp
	move.l	d0,savssp

	move.l	#$FE,a5
	add.l	adjust,a5
	move.b	#$00,$56C(a5)
	move.b	#$0C,$56D(a5)

	move.l	#$5FFE,a5
	add.l	adjust,a5
	move.b	#$22,$563(a5)
	move.b	#$02,$582(a5)
	move.b	#$18,$583(a5)

	move.b	#$61,$57C(a5)
	move.b	#$00,$57D(a5)
	move.b	#$1F,$57E(a5)
	move.b	#$78,$57F(a5)

	move.l	a5,a4
	move.l	a5,a3
	add.l	#$24F6,a4
	add.l	#$04F6,a3
	move.l	#300,d5
copy:	move.b	(a3)+,(a4)+
	dbf	d5,copy

	move.b	#$01,$2521(a5)
	move.b	#$6F,$254F(a5)
	move.b	#$6C,$2573(a5)

	move.b	#$4E,$2576(a5)
	move.b	#$75,$2577(a5)

	move.l	savssp,-(sp)	* Back to user mode
	move.w	#$20,-(sp)
	trap	#1
	addq.l	#6,sp

	pea	msg2		* "Finished" message
	move.w	#9,-(sp)
	trap	#1
	addq.l	#6,sp

exit:	pea	msg3		* Exit message
	move.w	#9,-(sp)
	trap	#1
	addq.l	#6,sp

	move.w	#1,-(sp)	* Wait for keypress
	trap	#1
	addq.l	#2,sp

	clr.w	-(sp)		* Back to the desktop
	trap	#1

	.data
msg1:	dc.b	"*** FORMAT PLUS ***",10,13,10,13
	dc.b	"Original program by Brian Duggan.",10,13
	dc.b	"Translated to 68000 assembly language",10,13
	dc.b	"by Charles F. Johnson."
	dc.b	10,13,10,13,0

wrong:	dc.b	27,"p * ABORT! * ",27,"q",10,13
	dc.b	"This program only works with disk-based",10,13
	dc.b	"versions of TOS! (5-29-85 or 6-20-85)"
	dc.b	10,13,10,13,0

msg2:	dc.b	27,"p Modification successful! ",27,"q",10,13
	dc.b	"--- Ready to format ---"
	dc.b	10,13,10,13,0

msg3:	dc.b	"Press any key to exit....",0

	.bss
savssp:	ds.l	1
adjust:	ds.l	1
