/*   LI.C			V1.1

		List files, size, date and time

  (c) COPYRIGHT 1986 BY THOMAS J. MYNAR
  THIS SOFTWARE MAY BE COPIED AND DISTRIBUTED FREELY WITH THE
  INCLUSION OF THIS NOTICE.  NO WARRANTY AND/OR USEABILITY IS
  IMPLIED.

*/

#include <b:gemlib.h>
#include <a:stdio.h>
#include <a:osbind.h>

#define  DAPRT 0
#define  MAXFILE 100

char	COPYRIGHT[]  =	{ "\15\12Copyright \275 1986 Tom Mynar\277\15\12\
Directory program  V" },
	VERSION[] =	{ "1.1 " },
	month_tx[38] =  {"JanFebMarAprMayJunJulAugSepOctNovDec"},
	n_fmt[6] =	{ "%9ld" },
	e_fmt[48] =	{ "\15\12\12Total of %ld files, in %4ld bytes, \
matching " },
	cr_lfs[8] =	{ "\15\12\12\12\12\15" },
	errntf[34] =	{ "\15\12File not found, Press any key" },
	fmt_d1[38] =	{ " %02d-%3s-%02d %02d:%02d" },
	hdr[56]    =	{ "\15\12    FILENAME      SIZE       DATE     TIME  \
FLAGS\15\12" },
	srnend[28] =	{ "\15\12Done.  Press any key" },
	tos[20] =	{ "\15\12Enter Filespec: " },
	wrkmsg[16] =	{ "\15\12Working" },
	r_w_flag[8] =	{ " R/x\15\12" },
	am_pm_str[6] =	{ " xm" };
char  dta[44], dirspec[64], out_buff[132], dirlst[80*MAXFILE];
char  month_date[4], fmt_num[10], fmt_nam[14];
long  error, filesize, tot_siz, tot_fil;
char  *filename, *at_buff, *at_p_n, *at_fmt, *at_nam, *at_srch, *at_bu2;
int   waitans, done, sizsrch;
unsigned short int date, time, day, month, year, hour, minute, index, jndex;
int   *at_fp, at_size;
short int SETA = 0x01, SETB = 0x02, SETC = 0x04, SETD = 0x08;
long  F_SUBDIR = 0x1F, F_ALLFILE = 0x00;
short int readonly = 0x01, subdir = 0x10, allfile = 0x00; vollab = 0x08;
short int attribute, drive_no, *at_int, lincnt;

/* put one char to printer */
static void putlst(c)
char c;
{	Bconout(DAPRT, c); }

/* Put a null terminated string to the printer */
static void prtstr(s)
char *s;
{	while (*s) putlst(*s++); }


/*  function to decode the DTA into file specifications of name
    size, date, time and attribute */
dec_file()
{
char one_char[2];
int  short_wrd;
	at_p_n = &fmt_num[0]; at_fmt = &n_fmt[0];
	filesize = *(long*) (&dta[26]);
	short_wrd = sprintf( at_p_n, at_fmt, filesize);
	fmt_num[9] = '\0';
/* fill filename string, left justified */
	filename = &dta[30];
/* get file attribute for folders and read/write flag */
	one_char[1] = dta[21];
	one_char[0] = '\0';
	attribute = *(short int *) (&one_char[0]);
/* decode date and time into printables (not bits) */
	date = *(short int*) (&dta[24]);
	year = date; year >>= 9;
	if ((year < 80) & (year > 0)) year = year + 80;
	if (year > 100) year = year - 100;
	month = date; month <<= 7; month >>= 12;
	if ((month>0) & (month<13))
	{	for (index=0;index<=2;index++)
			month_date[index] = month_tx[(month-1)*3+index];
		month_date[3] = '\0';
	}
	else
	{ 
		at_bu2=&month_date[0];strcpy( at_bu2, "XXX" );
	}
	day = date; day <<= 11; day >>= 11;
	time = *(short int*) (&dta[22]);
	hour = time; hour >>= 11;
	if	(hour > 12)
		{ am_pm_str[1] = 'p'; hour = hour - 12;	}
	else	{ am_pm_str[1] = 'a'; }
	minute = time; minute <<= 5; minute >>= 10;
}

/* print filename, get next filename */

static void loop()
{

	at_buff = &wrkmsg[0];
	index = Cconws( at_buff ); /* tell them we're working */
	done = 0;

	while	(done == 0) /* until end of file searches matching */
	{	dec_file();

/* determine if sub directory or not (affects filename printing) */
		for (index=72;index<=130;index++) out_buff[index]='\0';
		for (index=0;index<=72;index++)   out_buff[index]=' ';

		if	(attribute & subdir)
		{	at_buff=&out_buff[1];	strcpy( at_buff, filename );
			at_bu2=&fmt_num[0];
			strcpy( at_bu2, "<DIR>");
					/* put the filename at char pos 1 */
		}			/* put the text "DIR" where size goes */
		else
		{	if	(attribute & vollab)
			{	at_buff=&out_buff[0];
				strcpy( at_buff, filename );
				at_bu2=&fmt_num[0];
				strcpy( at_bu2, "<LABEL>");
					/* put filename at beginning */
 			}		/* put the text "LABEL" where size goes */
		  else
			{	at_buff=&out_buff[3];
                        	strcpy( at_buff, filename );
			}		/* put filename right shifted */
		}

/* determine read/write or read/only flag */
		if	(attribute & readonly)
		{	r_w_flag[3] = 'O'; } /* read only */
		else
		{	r_w_flag[3] = 'W'; } /* read/write */
		for (index=1;index<=15;index++)
			{if (out_buff[index]==0) {out_buff[index]=' ';}}
		at_buff = &out_buff[15]; at_bu2=&fmt_num[0]; strcpy(at_buff,at_bu2);
		for (index=15;index<=24;index++)
			{if (out_buff[index]==0) {out_buff[index]=' ';}}
		at_fmt = &fmt_d1[0]; at_buff = &out_buff[25];
		index = sprintf( at_buff, at_fmt, day, month_date, year, hour, minute );
		at_buff = &out_buff[41]; at_bu2=&am_pm_str[0]; strcpy( at_buff, at_bu2 );
		at_buff = &out_buff[44]; at_bu2=&r_w_flag[0]; strcpy( at_buff, at_bu2 );
		lincnt = lincnt+1;
		if	(lincnt == MAXFILE)
		{	Cconws( "\15\12Maximum files found, sorry, missing: " );
			Cconws( filename ); lincnt = lincnt-1;
		}
		at_buff = &out_buff[0];
		at_bu2=&dirlst[(lincnt-1)*80]; dirlst[(lincnt-1)*80]='\0';
		strcpy( at_bu2, at_buff );
		tot_siz = tot_siz + filesize;
		tot_fil = tot_fil + 1;

		index = Dsetdrv( drive_no );
		error = Fsnext();
		if	(error == -49)
		{	done = -1; /* end loop */ }
		else
		{	if	(error < 0 )
			{	printf( " Error from F_SNEXT %ld\n", error);
				waitans = getch(); exit(0);
			}
		}
	}
}

/* MAIN LOOP */

main( argc, argv )
int  argc;
char *argv[];
{

	appl_init();     /* Set the system up to do GEM calls */

	if	(argc != 2) /* print header if entry with no parms */
	{	at_buff = &COPYRIGHT[0]; Cconws( at_buff );
		at_buff = &VERSION[0];   Cconws( at_buff );
	}
	error = Fsetdta(dta);   /* setup data area */
	if	(error < 0)
		{ printf( "\nError from F_SETDTA %ld\n", error);
		  waitans = getch();
		  exit(0);  }

while	(0 == 0) /* forever */
{
	lincnt  = 0;
	tot_siz = 0;
	tot_fil = 0;
	for (index=0;index<=131;index++) out_buff[index]='\0';
	for (index=0;index<=63;index++)  dirspec[index]='\0';

/* ask user for filename specification and look for the first file */
	at_fmt = &tos[0];          /* pointer to screen prompt */
	Cconws( at_fmt );  /* output to screen */
	if	(argc == 2)
	{	at_buff = &out_buff[2]; out_buff[2] = '\0';
		strcpy( at_buff, argv[1] ); Cconws( at_buff );
	}
	else
	{	at_buff = &out_buff[0]; out_buff[0] = '\62';
		Cconrs( at_buff );
	}

	if	(out_buff[3] == ':') /* set drive if user specified it */
	{	if ((out_buff[2] || 40) == 'a')  drive_no = SETA;
		if ((out_buff[2] || 40) == 'b')  drive_no = SETB;
 		if ((out_buff[2] || 40) == 'c')  drive_no = SETC;
		if ((out_buff[2] || 40) == 'd')  drive_no = SETD;
	}
	at_buff = &out_buff[2];     /* reset pointer to real start of text */
	at_bu2  = &dirspec[0]; dirspec[0] = '\0';
	strcpy( at_bu2, at_buff );  /* save the search string */

/* search for the first folder */
	index = Dsetdrv( drive_no );
	error = Fsfirst( at_buff, F_SUBDIR );
	if	(error < 0)            /* abort with error message */
	{	if	(error != -33)
		{	printf( " Error from F_SFIRST %ld\n", error);
			waitans = getch();
			exit(0);
		}
		else
		{	at_buff = &srnend[0]; /* tell user the end */
			index = Cconws( at_buff );
			 waitans = getch();
		}
	}
	else
	{

/* print header to printer, lookup and decode filenames */
		at_fmt = &hdr[0];
		prtstr( at_fmt );
		loop();
/* print all filenames (sort goes here) */
		for (index=0;index<=lincnt;index++)
			{ at_buff=&dirlst[(index)*80]; prtstr( at_buff ); }
/* print totals, ask if we continue now */
		at_buff = &out_buff[0];
		at_fmt = &e_fmt[0];
		index = sprintf( at_buff, at_fmt, tot_fil, tot_siz );
		prtstr( at_buff );
		at_srch = &dirspec[0]; prtstr( at_srch );
		at_bu2  = &cr_lfs[0];  prtstr( at_bu2 );
		at_buff = &srnend[0]; /* tell user we're done */
		if	(argc != 2)   /* if entry with a command */
		{	Cconws( at_buff ); waitans = getch();
			if	( waitans == 3  )/*  exit if CTRL/C */
				exit(0);
		}
		else
		{	exit(0);
		}
	}
} /* end of forever */

}
