#include <stdio.h>
#include <osbind.h>

#define COPYBUF 0x5a000L
        /* 512 bytes * 9 sectors * 80 tracks */


#define MAGIC 0x087654321L
#define VIRGIN 0xe5e5
#define BUFLEN 8*1024
#define NUMSEC 80*9     /* 720 sectors */

long bufadr;    /* address of copy buffer */
char buf[256];
char fmtbuf[BUFLEN];

main()
{
        int old_res,choice,dfalt,hi,rd_flag;

        tf_init(80);
        dfalt = 0;      /* set initial default */
        hi=1;
        rd_flag=FALSE;
        old_res=Getrez();
        if (old_res==0) Setscreen(-1L,-1L,1);

        title("Reasonable Disk Copier","Version 1.7 - December 23, 1985");

        bufadr = Malloc(COPYBUF);
        /* allocate COPYBUF size buffer */
        if (bufadr==0L) {
          cls();
          center("Runs only on systems with 1 Meg upgrade or TOS in ROM!",12);
          error("NOT ENOUGH MEMORY TO RUN!  Press [RETURN]");
          return;
        }

        do {
                cls();
                center(
                "Reasonable Disk Copier   V1.7 - December 23, 1985",0);
                center("Copyright 1985 by Michael Curry",1);
                center(
                 "CIS 72507,2146 or The Key System BBS (415) 352-5528",3);
                
                hilite();
                center("FOR SINGLE SIDED DISKS and 1 MEG RAM UPGRADE ONLY!",22);
                lolite();
                center("0.  Return to desktop     ",9);
                center("1.  Read source in drive A",11);
                if (rd_flag) {
                        center("2.  Write to drive A only ",13);
                        center("3.  Write to BOTH A AND B ",14);
                }
                choice=get_int("Enter selection ",17,-1,0,hi,dfalt);
                dfalt = choice;

                switch (choice) {
                        case 0:
                                if (old_res==0) Setscreen(-1L,-1L,0);
                                return;
                                break;
                        case 1:
                                if (reed()==0) {
                                        dfalt=2;
                                        hi=3;
                                        rd_flag=TRUE;
                                }
                                break;
                        case 2:
                                writ(0);
                                break;
                        case 3:
                                writ(0);
                                writ(1);
                                break;
                } /* switch */

        } while (1);
}


reed()
{
        clr_eos(2,0);
        center("[ Reading disk into memory ]",8);
        if (read_buf()) {
                error("Error reading source disk - press [RETURN] ");
                return(1);
        }
        return(0);
}

writ(drive)     /* format and write drive */
int drive;
{

        clr_eos(2,0);

        hilite();
        sprintf(buf,"[ FORMATTING drive %c ]",(char) drive+'A');
        center(buf,8);

        cursor(12,0);

        strings(80,'+');
        cursor(12,0);
        lolite();
        if (format(drive,80,1)) 
                error("Error formatting drive!  Press [RETURN] ");
        else {
                clr_eos(8,0);
                hilite();
                sprintf(buf,"[ WRITING drive %c ]",(char) drive+'A');
                center(buf,8);
                lolite();
                
                if(write_buf(drive)) 
                        error("Error writing disk - Press [RETURN] ");
        }
        bell(10);
        return;

}

read_buf()
{
        return(Rwabs(2,bufadr,NUMSEC,0,0));
                                /* read into buf starting at first 
                                        sector */
}

write_buf(n)    /* write to drive n */
int n;
{
        int temp;
        verify(0);      /* turn off verify */
        temp=Rwabs(3,bufadr,NUMSEC,0,n);
        verify(1);      /* turn on verify */
        return (temp);
}


format(drive, ntracks, nsides)
int drive, ntracks, nsides;
{
        int track, side;
        char *p;
        curs_off();
        for (track = 0; track < ntracks; track++) {
                for (side = 0; side < nsides; side++) {
                        putchar('*');
                        if (fmt_one(drive, track, side)) {
                                fmt_fail(track, side);
                                return(1);
                        }
                }
        }
        /*
         * Format is complete, now zero the first few tracks
         */
        for (p = fmtbuf; p < &fmtbuf[BUFLEN]; p++)
                *p = 0;
        if (Flopwr(fmtbuf, 0L,  drive, 1, 0, 0, 9)) return(1);

        if (Flopwr(fmtbuf, 0L,  drive, 1, 1, 0, 9)) return(1);
        /*
         * OK so far, now create and write the boot sector
         */
        Protobt(fmtbuf, 0x1000000L, (ntracks >= 80 ? 2 : 0) + nsides - 1, 0);
        if (Flopwr(fmtbuf, 0L,  drive, 1, 0, 0, 1)) return(1);

        curs_on();
        return(0);
}



fmt_one(drive, track, side)
int drive, track, side;
{
        return(Flopfmt(fmtbuf, 0L, drive, 9, track, side, 1, MAGIC, VIRGIN));
}


fmt_fail(track, side)
int track, side;
{
        char *x;

        printf("Bad sectors on track %d, side %d:\n", track, side);
        for (x = fmtbuf; *x; x++)
                printf("%d ", *x);
        printf("\nDisk may be unusable.\n");
}


error(s)
char s[];
{
        center(s,22);
        input(buf,10);
        return;
}

bell(num)
int num;
{
        int i,j;
        for(i=0;i<num;i++) {
                for(j=0;j<80;j++) putchar(7);
        }
        return;
}


verify(flag)    /* set floppy verify on or off */
int flag;       /* flag - 0 = off, non-zero =on */
{
        long save_ssp;  /* temp holding area for supervisor stack pointer */
        int *fverify;

        fverify=0x444L;

        save_ssp = Super(0L);   /* toggle into supervisor mode */

        if(flag) *fverify=0xffff;
        else *fverify=0;

        Super(save_ssp);
        return;
}
