
{Requires AUXSUBS.PAS and procedure ABORT.                   
Read the text file with the Pascal name InFile into array Arr.
Set the value of NbrBytes to the actual number of bytes in Arr.
Errors are handled internally, so if the procedure returns,
the read was sucessful.
If Debug is TRUE, messages showing progress will be shown on the monitor.
Sample usage: TYPE T857 = PACKED ARRAY[1..50000] OF char;
              VAR MyArr : T252;
              proc
              ReadFile('E:\ABC.TXT',MyArr,N_Bytes,TRUE);           }
              
PROCEDURE ReadFile(InFile:string; VAR Arr:T857; VAR NbrBytes:long_integer;
                    Debug:boolean);
  VAR FSize : long_integer;   Handle:integer; MyCName : c_string;

FUNCTION FileSize(FileName : path_name):long_integer;
  {Return the length of a file in bytes.  The file name in a standard Pascal
  form must be provided as a parameter.    
  Returns TOS status if error, e.g., -33, file not found.}
TYPE
  pack14 = PACKED ARRAY[1..14] OF char;
  cstring = PACKED ARRAY[1..80] OF char;
  DTA_Type = PACKED RECORD
               reserved : PACKED ARRAY[0..19] OF byte;
               resvd    : byte;
               Attribute: byte;
               Time     : integer;
               Date     : integer;
               FileSize : long_integer;
               F_Name   : pack14;
             END {record};
  S80 = string[80];

VAR
  Addr       : DTA_Type;
  Attributes : byte;
  S2         : s80;
  C_FileName : c_string;
  Status   : integer;

  PROCEDURE SetDTA(VAR Addr : DTA_Type);
    GEMDOS($1A);

  FUNCTION SearchFirst(VAR FileName   : c_string;
                           Attributes : integer)
                           : integer;
    GEMDOS($4E);

  BEGIN {getfilesize}
    SetDTA(Addr);
    P_TO_CSTR(FileName,C_FileName);
    MyCName := c_FileName;
    Attributes := $07;
    Status := SearchFirst(C_FileName,Attributes);
    IF Status < 0
      THEN FileSize := Status
      ELSE FileSize := Addr.FileSize;
  END {getfilesize};

    {Modes:  0 - Read    1 - Write   2 - Read/Write
                  Value = Handle                 }
  FUNCTION GEMOPEN(VAR C_Name:c_string; Mode:integer):integer;
    GEMDOS($3D);
  
    {Value = number actually read.}
  FUNCTION GEMREAD(Handle:integer; NbrBytes:long_integer; 
               VAR Adr:T857):long_integer;
    GEMDOS($3F);    
    
    {Value = 0 THEN good close.}
  FUNCTION GEMCLOSE(Handle:integer):integer;   
    GEMDOS($3E);

    BEGIN{readfile}
      IF Debug
        THEN WriteLn('Procedure "ReadFile" called.');
      FSize := FileSize(InFile);
      IF FSize < 0
        THEN 
          BEGIN
            WriteLn(FSize);
            Abort('TOS error (above) on input file');
          END;  
      IF Debug     
        THEN WriteLn('File size:',FSize);
      Handle := GEMOPEN(MyCName,0);
      NbrBytes := GEMREAD(Handle,FSize,Arr);
      IF Debug
        THEN WriteLn('Number read:',NbrBytes);
      IF NbrBytes < FSize
        THEN 
          BEGIN
            WriteLn(NbrBytes);
            Abort('Number bytes read (above) wrong.');
          END;
      {Assert: Arr contains a copy of the entire text file.}      
    END{readfile};


