.TH MONTH 1L "Pyramid OSx" "" "User Contributed Software"
.SH NAME
month \- a visual calendar and time/event organizer
.SH SYNOPSIS
.B month
[
.B \-ABCdv
] [
.B \-N
[ arg ]]
.SH OPTIONS
.TP
.B \-d
Create background daemon that will wake up at 15 minute intervals 
during the current login session, 
check your event database, and print a message to your
terminal with a bell if it finds an event that is 15 minutes, or less, away.  
It will do this on invocation, then 
every 15-minutes until killed or you log out.
.TP
.B \-A
Output the 
.I month 
data file in a format compatible with 
.I appt (1). 
.TP
.B \-B
Output the current day's events.
.TP
.B \-C
Output the 
.I month 
data file in a format compatible with
.I calendar (1).
.TP
.B \-L
Output the lunar picture of what the moon will
look like at 11:00PM of the current day, and exit.
.TP
.B \-N [ arg ]
Output the current day's events in a format compatable with
.I nag (1).
An optional argument 
.B arg 
specifies what program 
.I nag
should invoke for the user (the default is
.I echo
).
.TP
.B \-v
Output the version ID of 
.I month
being run. 
.SH DESCRIPTION
.TP
.B Overview
.br
.sp 1
.I Month 
displays a calendar of the current month of the current year,
with the current day highlighted.  
It then allows the user to browse to any month/day/year, 
and to schedule and recall events for a day or for some regular 
repeating series of days.
Note that the UPPER/lower case of commands are significant.
.br
.TP
.B Screen Areas
.br
.sp 1
There are four distinct areas of the screen:  the 
.I days 
area where the days of the month are listed in calendar format, the 
.I months 
area where the months of the year are listed, the 
.I years 
area where a sequence of years are listed, and the 
.I schedule 
area, which may be blank and occupies lines 19-24 on the terminal 
(lines below 24 are not used).
.br
.TP
.B Commands
.br
.I Quitting
.br
.sp 1
You may type 'Q' almost any time to quit.  This will update
the event database if any changes have been made.
The event database is a file called 
.B .month 
in your home directory.
.I <CNTL-c> 
can be used any time for an immediate abort and no event database update.
When you quit, you will be informed of the update status of your event database.
.br
.sp 1 
.I Cursor motion
.br
.sp 1 
The 
.B h, l, k, 
and 
.B j 
keys are used to move the cursor left, right, up and down respectively 
within a screen area.  
Sometimes, as explained later, 
.B j 
and 
.B k 
will not work, and a
.I <TAB> 
or 
.I <CR>
provides movement between fields in a circular fashion.
.br
.sp 1 
.I Selection
.br
.sp 1 
.I <CR> 
and 
.I <LF> 
are used to select items/commands at the cursor position.
.br
.sp 1 
.I Direct entry of numbers
.br
.sp 1 
The user may type the number of a desired month, day, or year
whenever the cursor is appropriately positioned.  
This is true in all screen areas.  
.I <ESC> 
can be used to abort any function.
.br
.sp 1 
.I Scrolling numbers
.br
.sp 1 
In the schedule area, numbers may be scrolled forwards and
backwards with the 
.I <SPACE> 
and 
.I <BACKSPACE> 
keys respectively.
This is the only way to change hours and minutes.
.br
.sp 1 
.I Time browsing
.br
.sp 1 
The keys 'm', 'd' and 'y' are used to move into the months area, the
days area or the years area respectively.  This is only when
time browsing in these three panes.  To get to a particular
month or year, move to the appropriate area and onto the
desired month or year, and select it via 
.I <CR>.
Years may be
scrolled a year at a time by using the scroll areas marked
by '<<' and '>>'.  Attempting to move passed these areas will
scroll by one year, selecting them scrolls by ten years.
The last month of the previous year, or the first month of
next year, may be obtained by selecting the area above
January or below December respectively.  
The cursor is the positioned for immediate return via a later selection.
.br
.sp 1
The keys 
.B n 
and 
.B p 
can be used to go to the next or previous month,
day, or year, depending on the screen area you are in.
.br
.sp 1
The 
.B M 
key will mark a specific date.  You will be prompted for
an identifier that is a single digit between '0' and '9'.
Once a mark has been set at a certain date, you may jump to
that date from any other date with the command below.
.br
.sp 1
The 
.B G 
key controls movement to a previously set mark.  
You will be prompted for the mark's identifying digit.
.br
.sp 1
The key 
.B ';' 
provides access directly to the last date you viewed that
was in a different month than currently displayed.  
Use the same command again to return to where you were originally.
.br
.sp 1
The
.B T 
key goes directly to the actual, real current date.
This is the date initially displayed on startup.
.br
.sp 1
The key 
.B '/' 
allows direct access to a date to be fully specified by the user.  
A prompt is given and the user should respond with
a date in the form m/d/y, such as 5/6/86.  Years less than
100 are assumed to be in this century, hence, 5/6/80 is the same as 5/6/1986.
.TP
.B Overviewing a day
.br
.sp 1
The
.B O 
key will fill the schedule area with a read only view
of your day according to your event database.  
Four six-hour grids appear showing the hours of the day 
that have been pre-scheduled.  
The cursor must be placed on the day to be viewed with this function.
.TP
.B Overviewing a month
.br
.sp 1
The 
.B A 
key will mark all the days on the calendar that have
at least one event posted.  This feature is especially
useful before scanning; described next.
.TP
.B Scanning events
.br
.sp 1
The 
.B S 
key will cause a sequential list of events for the current day
to be displayed in the schedule area.  The events for any given
day may be scanned, deleted, or modified.
After displaying each one, the prompt "
.B [n,p,d,e,q]
" is put up and will respond to these character commands:
.br
.sp 1
.I 'n':
go to next event
.br
.I 'p':
go to previous event
.br
.I 'd':
delete this event
.br
.I 'e':
edit this event as during a posting described below
.br
.I 'q':
quit the scan and return to calendar
.br
.I <ESC>:
same as 'q'
.br
.TP
.B Every event scan
.sp 1
.I 'E'
will display, one at a time, absolutely every event
in your event database.  The prompt "
.B ['n','q']
" is displayed
and will respond to these character commands:
.br
.I 'n':
go to next event
.br
.I 'q':
quit the scan and return to calendar
.br
.I <ESC>:
same as 'q'
.br
.TP
.B Posting an event
.sp 1
.I 'P'
is the command used to post an event.  The
cursor is placed into the schedule area with a host of
information displayed.  
.sp 1
To abort  at any point, use 
.I <ESC>.
.sp 1
The cursor first appears on the first line of the schedule area.  
This line gives the starting date for the event, and when it shall occur.  
The user may move through the highlighted starting date field
(using the 
.B h
and
.B l
keys) and change the month, day or year by scrolling with 
.I <SPACE> 
and 
.I <BACKSPACE>,
or by direct input.  
.br
.sp
The other fields in this first line may also be moved onto and selected
in a similar fashion (but without direct entry).
.br
.sp
.I <TAB> 
will move the cursor to the next line that contains the
time that the event occurs.  
Again, the 
.B h,
.B l,
.I <SPACE>,
and 
.I <BACKSPACE>
keys manipulate the hours and minutes fields.
The AM/PM indicator changes as the hours scroll across 12:00 boundaries.  
.br
.sp
.I <TAB> 
will move the cursor to the next line that gives the duration of the event, 
and it is edited in the same fashion.  
.br
.sp
.I <TAB> 
moves the cursor to the next line that is a one line description of the
event, to be typed whenever the cursor is placed here.
.I <TAB> 
moves the cursor the last line in the schedule area and
allows the user to select ACCEPT or CANCEL.  
The 
.B h
and 
.B l
keys toggle between ACCEPT and CANCEL.
Pressing
.I <RETURN>
when the cursor is in the ACCEPT field will put the event 
into the user's event database, after verification.
CANCEL aborts the process.  
.br
.sp
The
.I <TAB> 
key can be used to circulate through the fields. 
.TP
.B Event scheduling
.sp 1
When and how often will an event occur?  This information
is contained in the first line of the schedule area.  The
date entered there is the starting date for the event,
that is, the event will not be recalled until that date.
This date is best entered by browsing to it, placing the
cursor in the days area on the desired day, and then
type 'P' to post the event, in which case the desired date
automatically appears as the default, but may be edited.
.br
.sp
In the following examples, only the fields that need to be
selected are mentioned, all others should be turned off.
(not highlighted)  Examples:
.ta +2.5i
.br
.sp 1
.I March 5, 1990 (once only):	
.B 3/5/1990
.br		
.sp 1
.I Every Tuesday and Wednesday:	
.B m/d/y every TueWed
.br	
.sp 1
.I The 7th of each month:	
.B m/7/y monthly
.br		
.sp 1
.I Each July 4th:	
.B 7/4/y yearly
.br
.sp 1
.I The 2nd and last sunday of 
.I each month:
.B m/d/y monthly every 2nd last Sun
.br
.sp 1
.I The 1st and last friday of 
.I each year:
.B \ \ m/d/y yearly every 1st last Fri
.br
.sp 1
.I Every other thursday:	
.B m/d/y every 2nd Thu
.br
.sp 1
Note, this will include the 1st, 3rd, 5th, 7th, etc.
thursday, 
.I starting 
from the specified m/d/y
.TP
.B Miscellaneous
.sp 1
The 
.B L 
key stands for lunar, and causes a picture of what the moon will
look like at 11:00PM on the day on which the cursor is placed.
.I <CNTL-L>
or 
.I <CNTL-R>
will redraw the screen.
.br 
.sp 1
The 
.B F
key is used for storing event descriptions to a file.  
The user is prompted for whether he would like to store ALL the events
in his database or just those for the current day.  
The user is then prompted for a file name, and if that file exists already,
the user is given a chance to abort the operation or continue.
.SH EXAMPLES
.br
.sp 1
.ti +1i
cp \ $HOME/.apptrc \ $HOME/.appt\ ;\ month -A \ >> \ $HOME/.appt
.sp
.br
month -N > \ $HOME/.nag\ ;\ nag
.sp
.ti -1i
.SH AUTHORS
.ta +1.15i
Jeff Bauer	(bauer@etc)
.br
Robert Dextor	(robertd@tekigm2)
.br
Marc Ries	(ries@trwrb)
.br
Tom Stoehn	(tims@zeus)
.SH FILES
$HOME/.month
.SH SEE ALSO
appt (1), calendar (1), and nag (1).
.SH DIAGNOSTICS
month: unknown option \fIarg\fR 
.br
Usage: month [-A] [-B] [-C] [-d] [-N [arg]] [-v]
.SH BUGS
Few attempts have been made to prevent the user from browsing
through negatively numbered years or years with more than four
digits in them, the latter causing the years area to get messed up,
but remains functional.
Rarely, events with a starting date before the year 1753,
will not be recalled correctly.

With the 
.B -A 
flag, any date that does not have a time that pertains
to it (i.e. birthdays, holidays, ...), set the starting time to 12:00 AM. 
.I Month 
requires a starting time whereas 
.I appt 
does not.
.SH DATE
2/9/87
