#include <stdio.h>
#include <stddef.h>
#include <string.h>

int main(int argc,char **argv)
{
int	count,
	quiet;
	
	if (argc < 3) {
		fprintf(stderr,"sr - String Replace\n");
		fprintf(stderr,"Usage:  sr [-q] <search string> <replace string> <file> [file...]\n");
		fprintf(stderr,"        -q initiates quite mode\n");
		exit(0);
	}

	if ((strcmp(argv[1],"-q") != 0) && (strcmp(argv[1],"-Q") != 0)) {
		quiet = 0;
		count = 3;
	}
	else {
		quiet = 1;
		count = 4;
	}
	
	for (;count < argc;count++) {
		if (quiet != 1) {
			fprintf(stdout,"Processing file:  %s\n",argv[count]);
		}
		do_file(quiet,argv[count],argv[count-2],argv[count-1]);
	}
	exit (0);
}

int do_file(int quiet,char *filename,char *sstring, char *rstring)
{
char	ibuf[1025],
	temp[1025],
	*sp,
	tfilename[] = "replace.tmp";
FILE	*sfile,
	*tfile;
int	count = 0;

	if ((sfile = fopen(filename,"r")) == NULL) {
		fprintf(stderr,"Couldn't open file:  %s\n",filename);
		return 1;
	}


	if ((tfile = fopen(tfilename,"w")) == NULL) {
		fprintf(stderr,"Couldn't open temporary file: %s\n",tfilename);
		return 1;
	}

	while (fgets(ibuf,1024,sfile) != NULL) {
		while ((sp = strstr(ibuf,sstring)) != NULL) {
			strcpy(temp,sp);
			strcpy(sp,rstring);
			strcpy((ibuf + strlen(ibuf)),(temp + strlen(sstring)));
			count++;
		}
		fputs(ibuf,tfile);
	}
	fclose(tfile);
	fclose(sfile);
	remove(filename);
	rename(tfilename,filename);
	if (quiet != 1) {
		fprintf(stdout,"%d replacements made\n",count);
	}
	return 0;
}
